## unit entity (unit_entity.gd)
WIP! I am trying to get this as close to Godot Docs as possible. with few exceptions,)  
extended from kinematic body  
the base of all unit types. Infantry, Tanks, Turrents, Airplanes, Decoys, you name it.

It's also the base of mecha, but that needs it's own file. (SO BIG!)


## Table of Contents
1. [Scene Tree](#Scene-Tree)
2. [Properties](#Properties)
3. [Methods](#Methods)
4. [Constants](#Constants)
5. [Property Descriptions](#Property-Descriptions)
6. [Method Descriptions](#Method-Descriptions)

## Scene Tree
The Scene structure for a unit_entity base node.

-Name-\Script insert here  
--pin(Collision shape)#physical collision and the rotary part of the unit.  
---Scene Root (The model)  
---area(Area)#used for collision like _on_colid()  
----hitbox(Collision Shape)  
---guns(Spatial)#used for guns aka gun variable  
----1(position3d)#Used for gun slots
----2(just like the last one for the second gunslot)    
----3(4,5,6,and so on.)   

## Properties
"String" gname  
"int" playern  
"int" faction  
"enum" unit_type  
"unit_type" unitmode  
"Color" skin   
"int" flightsp  
"int" landsp  
"int" speed  
"Vector3" vel  
"int" gravity  
"int" health  
"int" maxhealth  
"bool" is_flying  
"bool" is_over_land  
"bool" is_over_base  
"String" input_script  
"PoolByteArray" are_guns_firing  
"int" gun_multiplier
"PoolStringArray" gun  
"bool" is_decoy_ready   
"String" decoyammo  
"int" decoy_timer  
"int" dt_limit  

## Methods
"void" play_sound("String" value)  
"slave void" net_die()  
"void" die()  
"slave void" update_health  
"void" set_health  
"signal" set_over_base  
"int" set_ui_timer  
"void" gun_handler  
"void" play_anime  
"void" toggle_flight  
"slave void" update_transform  
"void" walk
<br><br>
"void" _on_goup  
"void" _on_godown  
"void" loadinguns  
"void" create_camsocket  
"void" create_hover  
"void" create_input_con  
"void" multiplier  
"void" create_sound  
"void" _on_colid  

## Constants
UNIT_TYPE:  
This helps in identification of a unit_entity. 

-    NORMAL - For the average unit, and Mecha  
-    CAPTURE - This means it can capture bases, infantry. 
-    TURRENT - This is a defensive stationary unit. 
-    FLY - This is a unit that flys, airplanes. 
-    ANTI_AIR - This aims only units that fly, 
-    DECOY - A sub-mecha that is given tasks by the mecha that made it. 
-    MECHA - The Player/AI controlled commanding unit.

## Property Descriptions
"String" gname:  
The Group name of the unit/mecha used to determine type typically.

"int" playern:  
short for player number, This is for the ownership of this
unit_entity. Say an ally commands units to attack a base, they
cannot command your's on accident. Another use is determining
the player's controller. Though this needs to be changed 
for the sake of netplay.  

"int" faction:  
The Side this unit_entity is on. This is used for determining who captures a base. Who is friendly. What projectiles will damage the unit_entity.  

For mecha and decoy it does a bit more. it determines spawn, and what bases will heal. 

"enum" unit_type:  

(See Unit type constant)

"unit_type" unitmode:  

This is the set identification of the unit. I'll explain in this example: (Token from AI_unit.gd)  
```
	if((current_state != AI_State.TURRENT)&&(p.unitmode != p.unit_type.TURRENT)):
		mat...
	else:
		turrentmode(delta)
```
Here the script is trying to see if the unit_entity is a turrent, a stationary object. If it is then go to turrent mode. which just aims at other units that come close to it.

"Color" skin:  
The faction color so to speak of the unit. This is to tell the difference from friend and foe.

"int" flightsp:  
Short for flight speed. This the air speed that this unit goes at. Mostly used for mecha and decoy, when transforming from air to land and back again.  

Potential use:  
Maybe this could also be used for jetpack infantry, or helicopters.

"int" landsp:  
This is the land speed of the unit. The second part to the flightsp, this is used in conjunction with the toggle_flight function. This is also the speed of which most units move at.  
 
"int" speed:  
The current speed of the unit_entity. Here is an excerpt of the script to show you what I mean (in Walk function).     
```
	var movement = vel*speed
	move_and_slide(movement)
```
Right here the "let's just say this is a mecha" speed is 6. The Vel it is traveling in is (0,0,1). The movement variable would look like this (0,0,6). So move and slide will have mecha move on the positive z axis 6 spots. 

"Vector3" vel:  
This is the direction the unit is going. Example:  
```
    #This goes left at a speed of 1
    vel = Vector3(-1,0,0)
    move_and_slide(vel)
```

"int" gravity:  

"int" health:  

"int" maxhealth:  

"bool" is_flying:  

"bool" is_over_land:  

"bool" is_over_base:  

"String" input_script:  

"PoolByteArray" are_guns_firing:  

"int" gun_multiplier:

"PoolStringArray" gun:  

"bool" is_decoy_ready:   

"String" decoyammo:  

"int" decoy_timer:  

"int" dt_limit:  

## Method Descriptions
"void" play_sound("String" value):  
This plays a sound from the unit. the value is the resource path of the desired sound.  
Example:
```
play_sound("res://assets/audio/sounds/blaster.ogg")
```  


