## Spawn
The point where a mecha/player spawns at. It really is it's own thing.

## Table of Contents
1. [Scene Tree](#Scene-Tree)
2. [Properties](#Properties)
3. [Methods](#Methods)
4. [Constants](#Constants)
5. [Property Descriptions](#Property-Descriptions)
6. [Method Descriptions](#Method-Descriptions)

## Scene Tree
-spawn-\Script insert here  
--headquarters(If checked)  

## Properties
"String" gname
"int" faction

## Methods
"void" spawn_new  
"void" detect_game_mode  

## Constants
NONE

## Property Descriptions
"String" gname:
The Group name of the spawn. this is used for calls from the SceneTree.

"int" faction:  
The faction which the spawn allianced with. it could be  
0 neutral,  
1 blue side,  
2 red side,  

There is technically no limit on the number of factions. But this is the standard for most maps.

## Method Descriptions

"void" spawn_new("spawn.gd" pnode, "Dictionary" playerdata, "int" trackingn, "bool" is_respawn=false, "int" stat_lives=3):  
This spawns a new mecha at spawn, with the given playerdata.

The player data is based on match_setting.gd's add_player_setting.

Example:  
```
var spawn = [Object 404] #This is for setting the newly formed mecha, on where it needs to spawn the next time around
var trackingn = 3 #The placement/vcon this player uses
var lives = 2 #How many the next mecha will spawn with
var playerdata = {"input_con":input_script,
						"player_res": self.filename,
						"decoy_res":[decoyammo, decoy_timer],
						"units_res":unit_list,
						"parts_res":parts,
						"weapons_res":gun,
						"p_faction":faction,
						"nickname":nickname,
						"id":get_network_master(), #This is only for online play
						"playern":playern, #This is for local play's controller use
				}
spawn.spawn_new(spawn,playerdata,trackingn,true,lives)
```

"void" detect_game_mode():  
This determines the spawns gamemode, this is called via level.gd.

Example: #Tooken from level.gd  
```
get_tree().call_group("spawn","detect_game_mode")
```
