"""
CPU_PLAYER
"""
extends "res://scripts/mecha.gd"
var unit_waves = {	"capture_base":[0,0,0,0,1],
					"assult_base":[1,3,7,7,4],
					"Deploy_AA":[2,2,2,6,6],
					"Defensive_wave":[6,6,7,7,3],
					"Flankers":[1,1,5,4,4],
					"Tank_wave":[7,7,7,7,7]}
enum ENUM_STATES {
	ATTACK,
	DESTROY,
	DEFEND,
	HARASS #For DM
}
var current_step = 0
var current_state = ENUM_STATES.HARASS
var objective = null
var current_base_local = null #A Vector 3
var list_of_bases = []#0 = Global Posision 1 = distance from spawn, 2 = who's faction it's on
#Unit
var cpu_unit_ready_list = []
var drop_spot = null
var wait_timer = 10
var btimer = 0#Checks status on battle on 0, We don't need a Timer node for this.
var tbdis = null
#Enemy reading
var spotted_enemies = []
var target_enemy = null

## ATTACK
func get_bases(node_level,sub_node):#Gets the bases
	for base in node_level.get_node(sub_node).get_children():#2nd get the other bases
		var borin = base.get_global_transform().origin
		var bas = borin.distance_to(get_parent().get_global_transform().origin)
		list_of_bases.append([borin,bas,base.faction])
		if base.faction != faction:#IF there is a nearby uncapt base, go for the attack.
			if tbdis == null:
				tbdis = bas
				form_plan(base,ENUM_STATES.ATTACK)
			if bas < tbdis:
				tbdis = bas
				if base.is_in_group("headquarters"):
					form_plan(base,ENUM_STATES.DESTROY)
				else:
					form_plan(base,ENUM_STATES.ATTACK)

func update_bases():#an updater when something happens
	if get_tree().get_root().has_node("level"):
		var level = get_tree().get_root().get_node("level")
		if level.is_in_group("DB"):#IF the level is Destroy base.
			if level.has_node("bases"):
				get_bases(level,"bases")
			if level.has_node("hq"):
				get_bases(level,"hq")
		else:#IF level isn't in any other group, Then it must be in DM
			if level.has_node("hq"):
				for i in level.get_node("hq").get_children():
					if i.is_class("Position3D"):
						for j in i.get_children():
							if j.is_in_group("player"):
								form_plan(j,ENUM_STATES.HARASS)

func get_capt_base_near_location(poslocal):
	var tbi
	for base in list_of_bases:
		if base[2] == faction:
			if tbi == null:
				tbi = base[0].distance_to(poslocal)
				current_base_local = base[0]
			if base[0].distance_to(poslocal) < tbi:
				current_base_local = base[0]

func check_battle_status(delta):#After certain amout of time, determine next move AKA Repeat process
	btimer = btimer - delta
	if btimer < 0:
		current_step = 0

func attackmode(delta):
	#print("CPUplayer: ",playernum, current_step)
	if current_step == 0:
		toggle_flight()
		update_bases()
		get_capt_base_near_location(objective.get_global_transform().origin)
		current_step = 1
	elif current_step == 1:
		move_to_capt_base(delta)
		if is_over_base:
			stop()
			current_step = 2
	elif current_step == 2:
		create_units(unit_waves['assult_base'],8)
	elif current_step == 3:
		wait_for_units(delta)
	elif current_step == 4:
		find_drop_spot(delta)
	elif current_step == 5:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Deploy_AA'],11)
	elif current_step == 6:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 7:
		find_drop_spot(delta)
	elif current_step == 8:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['assult_base'],11)
	elif current_step == 9:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 10:
		find_drop_spot(delta)
	elif current_step == 11:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['capture_base'],7)
	elif current_step == 12:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 13:
		find_drop_spot(delta)
	elif current_step == 14:
		command_selected(5)#Order an Attack
		toggle_flight()
		btimer = 30
		current_step = 15
	elif current_step == 15:
		chase(objective.get_global_transform().origin,delta)
		check_battle_status(delta)

## DESTROY
func destroymode(delta):
	#print("CPUplayer: ",playernum, current_step)
	if current_step == 0:
		toggle_flight()
		update_bases()
		get_capt_base_near_location(objective.get_global_transform().origin)
		current_step = 1
	elif current_step == 1:
		move_to_capt_base(delta)
		if is_over_base:
			stop()
			current_step = 2
	elif current_step == 2:
		create_units(unit_waves['Flankers'],8)
	elif current_step == 3:
		wait_for_units(delta)
	elif current_step == 4:
		find_drop_spot(delta)
	elif current_step == 5:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Deploy_AA'],11)
	elif current_step == 6:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 7:
		find_drop_spot(delta)
	elif current_step == 8:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['assult_base'],11)
	elif current_step == 9:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 10:
		find_drop_spot(delta)
	elif current_step == 11:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Tank_wave'],7)
	elif current_step == 12:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 13:
		find_drop_spot(delta)
	elif current_step == 14:
		command_selected(5)#Order an Attack
		print(units_commandable)
		toggle_flight()
		btimer = 30
		current_step = 15
	elif current_step == 15:
		chase(objective.get_global_transform().origin,delta)
		check_battle_status(delta)
##DEFEND
func defendmode(delta):
	#print("CPUplayer: ",playernum, current_step)
	if current_step == 0:
		toggle_flight()
		update_bases()
		get_capt_base_near_location(objective.get_global_transform().origin)
		current_step = 1
	elif current_step == 1:
		move_to_capt_base(delta)
		if is_over_base:
			stop()
			current_step = 2
	elif current_step == 2:
		create_units(unit_waves['assult_base'],8)
	elif current_step == 3:
		wait_for_units(delta)
	elif current_step == 4:
		find_drop_spot(delta)
	elif current_step == 5:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Deploy_AA'],11)
	elif current_step == 6:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 7:
		find_drop_spot(delta)
	elif current_step == 8:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Defensive_wave'],11)
	elif current_step == 9:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 10:
		find_drop_spot(delta)
	elif current_step == 11:
		get_capt_base_near_location(objective.get_global_transform().origin)
		create_units(unit_waves['Defensive_wave'],11)
	elif current_step == 12:
		move_to_capt_base(delta)
		wait_for_units(delta)
	elif current_step == 13:
		find_drop_spot(delta)
	elif current_step == 14:
		command_selected(5)#Order an Attack
		print(units_commandable)
		toggle_flight()
		btimer = 30
		current_step = 15
	elif current_step == 15:
		chase(objective.get_global_transform().origin,delta)
		check_battle_status(delta)
##HARASS
func harassmode(delta):
	if(weakref(objective).get_ref()):
#		print("CPU player",weakref(objective).get_ref())
		chase(objective.global_transform.origin,delta)
## AI General Functions
func ai_handler(delta):
	if objective != null:
		if weakref(objective).get_ref() != null:
			if current_state == ENUM_STATES.ATTACK:
				attackmode(delta)
			elif current_state == ENUM_STATES.DESTROY:
				destroymode(delta)
			elif current_state == ENUM_STATES.DEFEND:
				defendmode(delta)
			elif current_state == ENUM_STATES.HARASS:
				harassmode(delta)

func form_plan(nodetarget,newstate):#Forms a plan based on the four states
	current_state = newstate
	objective = nodetarget
	current_step = 0
	emit_signal("_on_state_change",[current_state])

func move_to_capt_base(delta):
	chase(current_base_local,delta)

func chase(target,delta):#Chases a target (Often a player)
	var tarx = Vector3(get_global_transform().origin.x,0,0).distance_to(Vector3(target.x,0,0))
	if get_global_transform().origin.x < target.x:
		tarx = -tarx
	var tarz = Vector3(0,0,get_global_transform().origin.z).distance_to(Vector3(0,0,target.z))
	if get_global_transform().origin.z < target.z:
		tarz = -tarz

	var MATH = load('res://scripts/MATH.gd')
	vel = (Vector3(-MATH.npz(tarx),vel.y,-MATH.npz(tarz)))

	if target_enemy != null:
		if (typeof(weakref(target_enemy).get_ref()) != TYPE_NIL):
			aim(target)

func aim(target):
	var target_no_y = Vector3(target.x,pin.get_global_transform().origin.y,target.z)
	pin.look_at(target_no_y,Vector3(0,1,0))

func find_drop_spot(delta):
	if drop_spot == null:
		drop_spot = current_base_local.ceil() + Vector3(8,0,0)

	chase(drop_spot,delta)
	var gtoc = get_global_transform().origin.ceil()
	#print(gtoc,drop_spot)
	if (gtoc.x == drop_spot.x)||(gtoc.x == (drop_spot.x + 1))&&(gtoc.z == drop_spot.z)||(gtoc.z == (drop_spot.z + 1)):
		if inventory.size() > 0:
			drop_unit(inventory[0])
			inventory.remove(0)
			drop_spot = drop_spot + Vector3(2,0,0)
		elif inventory.size() == 0:
			drop_spot = Vector3(current_base_local.ceil().x + 8,0,drop_spot.z + 3)
			current_step = current_step + 1

func stop():
	vel = Vector3(0,0,0)

## BUILDING UNITS
func create_units(strategy,delay_time):#Creates waves of units
	for i in strategy:
		purchase_unit(unit_list[i],i)
	wait_timer = delay_time
	current_step = current_step + 1

func wait_for_units(delta):
	if wait_timer < 0:
		if is_over_base:
			if cpu_unit_ready_list.size() <= 0:
				current_step = current_step + 1
			else:
				pickup_unit(cpu_unit_ready_list[0])
				cpu_unit_ready_list.remove(0)
	else:
		wait_timer = wait_timer - delta

func add_unit_to_list(unit):
	cpu_unit_ready_list.append(unit)

func purchase_unit(unit,unitname = "Unknown"):
	if money > 0:
		money = money - unit[2]
		var qtimer = Timer.new()
		qtimer.set_wait_time(unit[1])
		qtimer.connect("timeout",self,"qtimer_out",[qtimer,unit[0],unitname])
		qtimer.start()
		add_child(qtimer)
		

func qtimer_out(timer,unit,unitname):
	add_unit_to_list(unit)
	timer.queue_free()

## COMBAT
func create_scanner():
	var sensor = Spatial.new()#Makes this so base collision doesn't freak out over noneexisted grandparent
	var scanner = Area.new()
	var cshape = CollisionShape.new()
	var shape = SphereShape.new()
	shape.radius = 54
	cshape.shape = shape
	scanner.add_child(cshape)
	scanner.connect("area_entered",self,"_on_spot")
	scanner.connect("area_exited",self,"_on_unspot")
	sensor.add_child(scanner)
	add_child(sensor)

func get_next_enemy(impobject):
	spotted_enemies.remove(spotted_enemies.find(impobject))
	if spotted_enemies.size() > 0:
		target_enemy = spotted_enemies[0]
	else:
		are_guns_firing[0] = 0
		are_guns_firing[1] = 0

func set_next_enemy(impobject):
	target_enemy = impobject
	spotted_enemies.append(impobject)
	if are_guns_firing[0] != 1:
		are_guns_firing[0] = 1
		are_guns_firing[1] = 1

##COLID
func _on_spot(area):
	var parea = area.get_parent()
	if parea.is_in_group("player"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			set_next_enemy(gparea)
	if parea.is_in_group("decoy"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			set_next_enemy(gparea)
	if parea.is_in_group("unit"):
		if parea.faction != faction:
			set_next_enemy(parea)

func _on_unspot(area):
	var parea = area.get_parent()
	if parea.is_in_group("player"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			if target_enemy == gparea:
				get_next_enemy(gparea)
	if parea.is_in_group("decoy"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			if target_enemy == gparea:
				get_next_enemy(gparea)
	if parea.is_in_group("unit"):
		if parea.faction != faction:
			get_next_enemy(parea)

## MAIN
func _physics_process(delta):
#	print("CPU",current_step)
	ai_handler(delta)

	if target_enemy != null:
		if(weakref(target_enemy).get_ref()):
#			print("CPU player",weakref(target_enemy).get_ref())
			aim(target_enemy.global_transform.origin)

func _ready():
	add_to_group("player faction"+str(faction))
	is_cpu = true
	get_node("recticle").set_visible(false)#"Disables" a unneeded aim recticle
	#Create a scanner
	create_scanner()

	add_user_signal("_on_state_change",[current_state])

	update_bases()
"""
DECOY
"""
extends "res://scripts/mecha.gd"
###A Object that acts a commanding unit for the player
#Description
var hname = "decoy"
var legiance = 0
var parent_player = null
#aihandler
enum ai_behavior_list {#The letters are placeholders
BUILD,
TURRENT,
TURRENTA,
HUNT,
BUILDA,
HUNTA,
HUNTB}
var ai_behavior_act = ai_behavior_list.HUNT
var spotted_enemies = []
var target_enemy = null
var current_step = 0
#building units
var unit_waves = {	"capture":[7,0,0,0,0],
					"defend":[6,6,7,7,3]}
var cpu_unit_ready_list = []
var current_base_local = Vector3(0,0,0) #A Vector 3
var wait_timer = 0
var drop_spot = null

##HUNT
func huntmode(delta):
	if(current_step == 0):
		if(target_enemy != null):
			current_step = 1
	elif(current_step == 1): 
		if(weakref(target_enemy).get_ref()):
			chase(target_enemy.global_transform.origin)
		else:
			current_step = 0

##TURRENT
func turrentmode(delta):
	if(current_step == 0):
		vel = Vector3(0,0,0)
		if(target_enemy != null):
			current_step = 1
	elif(current_step == 1): 
		if(weakref(target_enemy).get_ref()):
			aim(target_enemy.global_transform.origin)
		else:
			current_step = 0

##BUILD
func buildmode(delta):
	if(current_step == 0):
		if(get_tree().get_root().has_node("level")):
			var level = get_tree().get_root().get_node("level")
			if(level.is_in_group("DM")):
				set_ai_behavior(ai_behavior_list.HUNT)
		toggle_flight()
		drop_spot == null
		current_base_local = get_capt_base_near_location(global_transform.origin)
		current_step = 1
	elif(current_step == 1):
		print(hname,current_step,is_over_base,global_transform.origin)
		chase(current_base_local)
		if is_over_base:
			vel = Vector3(0,0,0)
			current_step = 2
	elif(current_step == 2):
		create_units(unit_waves['capture'],8)
	elif(current_step == 3):
		wait_for_units(delta)
	elif(current_step == 4):
		#This step makes it go down and beneath the terrain for some reason?
		find_drop_spot(delta)
	elif(current_step == 5):
		toggle_flight()
		is_over_base = false
		"""Until the bug where it gets beneath the terrain is fixed it will self destruct"""
		queue_free()

##Base management
func get_capt_base_near_location(pos):
	var nearest = Vector3(0,0,0)
	if(get_tree().get_root().has_node("level")):
		var level = get_tree().get_root().get_node("level")
		var dis = 150
		if(level.has_node("bases")):
			var bases = level.get_node("bases")
			for base in bases.get_children():
				if(base.faction == faction):
					var bdis = base.global_transform.origin.distance_to(global_transform.origin)
					if(bdis < dis):
						nearest = base.global_transform.origin
		if(level.has_node("hq")):
			var bases = level.get_node("hq")
			for base in bases.get_children():
				if(base.faction == faction):
					var bdis = base.global_transform.origin.distance_to(global_transform.origin)
					if(bdis < dis):
						nearest = base.global_transform.origin
	else:
		set_ai_behavior(1)
	return nearest

func purchase_unit(unit,unitname = "Unknown"):
	if(money > 0):
		money = money - unit[2]
		var qtimer = Timer.new()
		qtimer.set_wait_time(unit[1])
		qtimer.connect("timeout",self,"qtimer_out",[qtimer,unit[0],unitname])
		qtimer.start()
		add_child(qtimer)

func qtimer_out(timer,unit,unitname):
	cpu_unit_ready_list.append(unit)
	timer.queue_free()

func create_units(strategy,delay_time):#Creates waves of units
	for i in strategy:
		purchase_unit(unit_list[i],i)
	wait_timer = delay_time
	current_step = current_step + 1

func wait_for_units(delta):
	if(wait_timer < 0):
		if is_over_base:
			if cpu_unit_ready_list.size() <= 0:
				current_step = current_step + 1
			else:
				pickup_unit(cpu_unit_ready_list[0])
				cpu_unit_ready_list.remove(0)
	else:
		wait_timer = wait_timer - delta

func find_drop_spot(delta):
	if drop_spot == null:
		drop_spot = current_base_local.ceil() + Vector3(8,0,0)

	chase(drop_spot)
	var gtoc = get_global_transform().origin.ceil()
	#print(gtoc,drop_spot)
	if (gtoc.x == drop_spot.x)||(gtoc.x == (drop_spot.x + 1))&&(gtoc.z == drop_spot.z)||(gtoc.z == (drop_spot.z + 1)):
		if inventory.size() > 0:
			drop_unit(inventory[0])
			inventory.remove(0)
			drop_spot = drop_spot + Vector3(2,0,0)
		elif inventory.size() == 0:
			drop_spot = Vector3(current_base_local.ceil().x + 8,0,drop_spot.z + 3)
			current_step = current_step + 1
##Movement
func chase(target):
	var tarx = Vector3(get_global_transform().origin.x,0,0).distance_to(Vector3(target.x,0,0))
	if get_global_transform().origin.x < target.x:
		tarx = -tarx
	var tarz = Vector3(0,0,get_global_transform().origin.z).distance_to(Vector3(0,0,target.z))
	if get_global_transform().origin.z < target.z:
		tarz = -tarz

	var MATH = load('res://scripts/MATH.gd')
	vel = (Vector3(-MATH.npz(tarx),vel.y,-MATH.npz(tarz)))

	if target_enemy != null:
		if (typeof(weakref(target_enemy).get_ref()) != TYPE_NIL):
			aim(target)

func aim(target):
	var target_no_y = Vector3(target.x,pin.get_global_transform().origin.y,target.z)
	pin.look_at(target_no_y,Vector3(0,1,0))

##AI
func set_ai_behavior(value):
	if(typeof(value) == TYPE_INT):
		ai_behavior_act = value
		current_step = 0

func ai_handler(delta):
	if ((ai_behavior_act == ai_behavior_list.HUNT) || (ai_behavior_act == ai_behavior_list.HUNTA) || (ai_behavior_act == ai_behavior_list.HUNTB)):
		huntmode(delta)
	elif ((ai_behavior_act == ai_behavior_list.TURRENT) || (ai_behavior_act == ai_behavior_list.TURRENTA)):
		turrentmode(delta)
	else:
		buildmode(delta)

##SENSOR
func create_scanner():
	var sensor = Spatial.new()#Makes this so base collision doesn't freak out over noneexisted grandparent
	var scanner = Area.new()
	var cshape = CollisionShape.new()
	var shape = SphereShape.new()
	shape.radius = 104
	cshape.shape = shape
	scanner.add_child(cshape)
	scanner.connect("area_entered",self,"_on_spot")
	scanner.connect("area_exited",self,"_on_unspot")
	sensor.add_child(scanner)
	add_child(sensor)

func get_next_enemy(impobject):
	spotted_enemies.remove(spotted_enemies.find(impobject))
	if spotted_enemies.size() > 0:
		target_enemy = spotted_enemies[0]
	else:
		are_guns_firing[0] = 0
		are_guns_firing[1] = 0

func set_next_enemy(impobject):
	target_enemy = impobject
	spotted_enemies.append(impobject)
	if are_guns_firing[0] != 1:
		are_guns_firing[0] = 1
		are_guns_firing[1] = 1

func _on_spot(area):
	var parea = area.get_parent()
	if(parea.is_in_group("player")):
		var gparea = parea.get_parent()
		if(gparea.faction != faction):
			set_next_enemy(gparea)
	if(parea.is_in_group("decoy")):
		var gparea = parea.get_parent()
		if(gparea.faction != faction):
			set_next_enemy(gparea)
	if(parea.is_in_group("unit")):
		if(parea.faction != faction):
			set_next_enemy(parea)

func _on_unspot(area):
	var parea = area.get_parent()
	if(parea.is_in_group("player")):
		var gparea = parea.get_parent()
		if(gparea.faction != faction):
			if(target_enemy == gparea):
				get_next_enemy(gparea)
	if(parea.is_in_group("decoy")):
		var gparea = parea.get_parent()
		if(gparea.faction != faction):
			if(target_enemy == gparea):
				get_next_enemy(gparea)
	if(parea.is_in_group("unit")):
		if(parea.faction != faction):
			get_next_enemy(parea)

##MAIN
func _physics_process(delta):
	ai_handler(delta)

func _ready():
	#Add to decoy group
	add_to_group(hname)
	pin.add_to_group(hname)
#Change all settings that would be for player/CPU player
	remove_from_group(gname)
	pin.remove_from_group(gname)
	nickname[0] = nickname[0] + str(hname)
	gtdecoy = 0
	ammod = ""

	create_scanner()
"""
PLAYER
"""
extends "res://scripts/mecha.gd"
var is_mouse = false

var is_commanding = false #For when in Command mode

var is_buying = false
var is_other = false #When trying the other set of four
##Monitoring
func display_hint(value = "",altvalue = ""):
	if is_other:
		get_tree().call_group("hud","display_hint",playernum,altvalue)
	else:
		get_tree().call_group("hud","display_hint",playernum,value)

##Command
func command_handler():
	var one = Input.is_action_just_pressed(str(playernum)+"one")
	var two = Input.is_action_just_pressed(str(playernum)+"two")
	var three = Input.is_action_just_pressed(str(playernum)+"three")
	var four = Input.is_action_just_pressed(str(playernum)+"four")
	
	var tre = get_tree()
	if is_other:
		if one:
			command_selected(4)
		elif two || three || four:
			command_selected(0)
	else:
		if one:
			command_selected(2)
		elif two:
			command_selected(3)
		elif three:
			command_selected(5)
		elif four:
			command_selected(6)

func buy_handler():
	var one = Input.is_action_just_pressed(str(playernum)+"one")
	var two = Input.is_action_just_pressed(str(playernum)+"two")
	var three = Input.is_action_just_pressed(str(playernum)+"three")
	var four = Input.is_action_just_pressed(str(playernum)+"four")

	if is_other:
		if one:
			buy_a_unit(0)
		elif two:
			buy_a_unit(1)
		elif three:
			buy_a_unit(2)
		elif four:
			buy_a_unit(3)
	else:
		if one:
			buy_a_unit(4)
		elif two:
			buy_a_unit(5)
		elif three:
			buy_a_unit(6)
		elif four:
			buy_a_unit(7)

##Movement
func rot_cam():# Rotates the mesh too This is for mouse
	var midpoint = get_viewport().get_size()/2
	var mousepos = get_viewport().get_mouse_position()
	move_rect(midpoint,mousepos)

	var rectcord = Vector3(get_node("recticle").get_global_transform().origin.x,pin.get_global_transform().origin.y,get_node("recticle").get_global_transform().origin.z)
	pin.look_at(rectcord,Vector3(0,1,0))

func rot_cam_con(direction): # Rotates the mesh too This is for Controler
	get_node("recticle").translation = Vector3(direction.x,get_node("recticle").translation.y,direction.y)

	var rectcord = Vector3(get_node("recticle").get_global_transform().origin.x,pin.get_global_transform().origin.y,get_node("recticle").get_global_transform().origin.z)
	if pin.get_global_transform().origin != rectcord:
		pin.look_at(rectcord,Vector3(0,1,0))

##Main
func _input(event):
	if event.is_class("InputEventMouseMotion"):
		if is_mouse:
			rot_cam()
	
	if event.is_class("InputEventMouseButton") || event.is_class("InputEventKey") || event.is_class("InputEventJoypadMotion") || event.is_class("InputEventJoypadButton"):
		if event.is_action_pressed(str(playernum)+"charl"):
			vel.x = -1
		elif event.is_action_pressed(str(playernum)+"charr"):
			vel.x = 1
		elif (event.is_action_released(str(playernum)+"charl") && vel.x == -1) || (event.is_action_released(str(playernum)+"charr") && vel.x == 1):
			vel.x = 0
		if event.is_action_pressed(str(playernum)+"charu"):
			vel.z = -1
		elif event.is_action_pressed(str(playernum)+"chard"):
			vel.z = 1
		elif (event.is_action_released(str(playernum)+"charu") && vel.z == -1) || (event.is_action_released(str(playernum)+"chard") && vel.z == 1):
			vel.z = 0
			
		if !is_mouse:
			if event.is_action_pressed(str(playernum)+"aiml"):
				con_dir.x = -3
			elif event.is_action_pressed(str(playernum)+"aimr"):
				con_dir.x = 3
			elif (event.is_action_released(str(playernum)+"aiml") && con_dir.x == -3) || (event.is_action_released(str(playernum)+"aimr") && con_dir.x == 3):
				con_dir.x = 0
			if event.is_action_pressed(str(playernum)+"aimd"):
				con_dir.y = 3
			elif event.is_action_pressed(str(playernum)+"aimu"):
				con_dir.y = -3
			elif (event.is_action_released(str(playernum)+"aimd") && con_dir.y == -3) || (event.is_action_released(str(playernum)+"aimu") && con_dir.y == 3):
				con_dir.y = 0
			rot_cam_con(con_dir)
		
		if event.is_action_pressed(str(playernum)+"fly"):
			toggle_flight()

		if event.is_action_pressed(str(playernum)+"firep"):
			are_guns_firing[0] = 1
		elif event.is_action_released(str(playernum)+"firep"):
			are_guns_firing[0] = 0
		if event.is_action_pressed(str(playernum)+"fires"):
			are_guns_firing[1] = 1
		elif event.is_action_released(str(playernum)+"fires"):
			are_guns_firing[1] = 0
		if event.is_action_pressed(str(playernum)+"decoy"):
			if is_flying:
				
				are_guns_firing[2] = 1
		elif event.is_action_released(str(playernum)+"decoy"):
			are_guns_firing[2] = 0

		if event.is_action_pressed(str(playernum)+"buy"):
			is_buying = true
			display_hint('1/up='+unit_list[4][3]+' \n 2/down='+unit_list[5][3]+' \n 3/left='+unit_list[6][3]+' \n 4/right='+unit_list[7][3],'1/up='+unit_list[0][3]+' \n 2/down='+unit_list[1][3]+' \n 3/left='+unit_list[2][3]+' \n 4/right='+unit_list[3][3])
		elif event.is_action_released(str(playernum)+"buy"):
			is_buying = false
			display_hint()
		if event.is_action_pressed(str(playernum)+"pickup"):
			if is_flying:
				if is_over_base:
					var hud = get_node("/root/hud")
					var pickunit = hud.players_unit_ready_list[playernum]
					if pickunit.size() > 0 && (inventory.size() < 5):
						pickup_unit(pickunit[0])
						get_tree().call_group("hud","pickup_ready_unit",playernum)
				elif (units_pickupable.size() > 0):
					for unit_i in units_pickupable:
						pickup_unit(unit_i.get_filename())
						unit_i.queue_free()
					units_pickupable = []
				elif !is_over_base:
					if (inventory.size() > 0):
						drop_unit(inventory[0])
						inventory.remove(0)
		if event.is_action_pressed(str(playernum)+"command"):
			is_commanding = true
			display_hint('1/up=defend \n 2/down=seek \n 3/left=attack \n 4/right=destroy','1/up=follow \n ELSE=Patrol')
		elif event.is_action_released(str(playernum)+"command"):
			is_commanding = false
			display_hint()

		if event.is_action_pressed(str(playernum)+"other"):
			is_other = true
		elif event.is_action_released(str(playernum)+"other"):
			is_other = false

func _physics_process(delta):
	if is_buying:
		buy_handler()
	if is_commanding:
		command_handler()

func _ready():
	is_mouse = ProjectSettings.get("Game/Options/is_player_"+str(playernum)+"_mouse")
	if !is_cpu:
		get_tree().call_group(str(playernum)+"vcon","set_camsock",get_node("camsocket"))
"""
MECHA
"""
extends KinematicBody
###An the main controllable object of the game.
#Description
var gname = "player"
var is_cpu = false
var playernum = 0
var faction = 0
var spawn_point = null
var is_respawning = false
var nickname = ["player","ffffff"]

var lives = 3
export var health = 120
var maxhealth = health
export var healrate = 1
var money = 1150 #Enough to buy 4 mimics and a motor
export var flightsp = 25
export var landsp = 7

var vel = Vector3()
var speed = landsp
var con_dir = Vector2(0,0)#Aims for controller.

var is_flying = false
var is_over_base = false
var is_healing = false

var are_guns_firing = PoolByteArray([0,0,0])
var are_guns_ready = PoolByteArray([1,1,0])
var are_gt_limits = PoolIntArray([1,6,125])
var gun_multiplier = 8
var ammop = "res://objects/projectile/projectile.tscn"
var ammos = "res://objects/projectile/projectile.tscn"
var ammod = "res://objects/decoy/decoy7.tscn"
var gtprime = 0
var gtsecond = 0
var gtdecoy = 30
#Unit Buying
#0 = The scene of the unit to load,1 = The Time it takes, 2 = The unit cost in money, 3 = name of the unit
var unit_list = [	["res://objects/units/mimic.tscn",1, 200,"mimic"],
					["res://objects/units/motor.tscn",2, 350,"motor"],
					["res://objects/units/bazooka.tscn",2, 350,"bazooka"],
					["res://objects/units/turrent.tscn",10, 2200,"turrent"],
					["res://objects/units/airplane.tscn",7, 1700,"airplane"],
					["res://objects/units/jeep.tscn",4 , 500,"jeep"],
					["res://objects/units/antiair.tscn",4, 750,"anti-air"],
					["res://objects/units/tank.tscn",5, 1000,"tank"]]
#Unit Management
var inventory = []
var units_pickupable = []
var units_commandable = []

#Parts
var parts = ["",""]

var pin
var clarea #Claw area

##Sound
func create_sound():
	var sound = AudioStreamPlayer3D.new()
	sound.name = "sound"
	sound.max_distance = 0
	sound.unit_db = ProjectSettings.get("Game/Options/sound_volume")
	sound.max_db = 6
	sound.unit_size = 16
	sound.attenuation_model = sound.ATTENUATION_INVERSE_SQUARE_DISTANCE
	add_child(sound)
func play_sound(value):
	var lval = load(value)
	if has_node("sound"):
		var sound = get_node("sound")
		if lval != null:
			if sound.stream != lval:
				sound.stream = lval
				sound.play(0)
			if !sound.playing:
				sound.play(0)
		else:
			sound.playing = false

##Monitoring
func die():#If the mecha's health is below 0 destroy mech
	if(get_tree() != null):#if the scenetree exists (This is to prevent crashing on the victory screen)
		queue_free()
		if(is_in_group("player")):
			get_tree().call_group(str(playernum)+"vcon","set_camsock")
			lives = lives - 1
			var upwd = [unit_list,parts,[[ammop,gtprime],[ammos,gtsecond]],[ammod,gtdecoy]]
			get_tree().call_group("hud","respawn",lives,spawn_point,playernum,upwd,nickname)


func set_health(value):
	if(health > -1):#Prevents the player from dying/respawning twice
		if((health - value) <= maxhealth):
			health = health - value
			get_tree().call_group("hud","set_player_health","player_ui"+str(playernum),health)
			if health < 0:
				die()

func set_ui_timer(whatnum,value,string_bar):
	var gt = whatnum - (value*gun_multiplier)
	get_tree().call_group("hud","set_player_rate","player_ui"+str(playernum),string_bar,gt)
	return gt

##Command
func command_selected(ai_actions):
	for unt in units_commandable:
		unt.set_ai_behavior(ai_actions)

func buy_a_unit(unitvalue):
	if typeof(unitvalue) == TYPE_INT:
		if money > 0:
			money = money - unit_list[unitvalue][2]
			var tre = get_tree()
			tre.call_group("hud","purchase_unit",unit_list[unitvalue],playernum,money,unit_list[unitvalue][3])

func set_money(value):
	money = money - value
	get_tree().call_group("hud","set_player_wallet",playernum,money)

func pickup_unit(nunit,nunitname = "?"):
	inventory.append(nunit)

	var it_list = get_node("ui_inven/view/grid/it_list")
	var lb = Label.new()
	lb.set_text(nunitname)
	it_list.add_child(lb)

func drop_unit(nunit,gsound = "res://audio/sounds/laser-ozzy.ogg"):#Drops a unit/decoy
	var claw = get_node("claw")
	nunit = load(nunit).instance()

	nunit.legiance = playernum
	nunit.parent_player = self
	nunit.faction = faction
	nunit.set_global_transform(claw.get_global_transform())
	get_tree().get_root().get_node("level").add_child(nunit)

	var it_list = get_node("ui_inven/view/grid/it_list")
	if it_list.get_children().size() > 0:
		it_list.get_children()[0].queue_free()

##Weapons
func gun_handler(delta):
	if (are_guns_firing[0] == 1) && (are_guns_ready[0] == 1):
		fire_gun(1,ammop)
		are_guns_ready[0] = 0
		gtprime = are_gt_limits[0]
	elif(are_guns_ready[0] == 0):
		if gtprime < 0:
			are_guns_ready[0] = 1
		else:
			gtprime = set_ui_timer(gtprime,delta,"rateprime")
	if (are_guns_firing[1] == 1) && (are_guns_ready[1] == 1):
		fire_gun(1,ammos)
		are_guns_ready[1] = 0
		gtsecond = are_gt_limits[1]
	elif(are_guns_ready[1] == 0):
		if gtsecond < 0:
			are_guns_ready[1] = 1
		else:
			gtsecond = set_ui_timer(gtsecond,delta,"ratesec")
	if (are_guns_firing[2] == 1) && (are_guns_ready[2] == 1):
		drop_unit(ammod)
		are_guns_ready[2] = 0
		gtdecoy = are_gt_limits[2]
	elif(are_guns_ready[2] == 0):
		if gtdecoy < 0:
			are_guns_ready[2] = 1
		else:
			gtdecoy = set_ui_timer(gtdecoy,delta,"ratedecoy")
	if (are_guns_firing[0] == 0) && (are_guns_firing[1] == 0) && (are_guns_firing[2] == 0) && (get_node("sound").playing): 
		play_sound("")

func fire_gun(gun,gammo,gsound = "res://assets/audio/sounds/laser-ozzy.ogg"):#Fires the weapons
	var guns = get_node("pin/guns")
	var g = guns.get_node(str(gun))
	gammo = load(gammo).instance()

	if(typeof(weakref(g)) != TYPE_NIL):
		if(typeof(weakref(gammo).get_ref()) != TYPE_NIL):
			gammo.set_global_transform(g.get_global_transform())
			gammo.add_collision_exception_with(self)
			gammo.legiance = playernum
			gammo.faction = faction
			get_tree().get_root().add_child(gammo)
			
			play_sound(gsound)

func move_rect(midpoint,mousepos):#Displays where a shot will go

	var recx = Vector2(midpoint.x,0).distance_to(Vector2(mousepos.x,0))
	if mousepos.x < midpoint.x:
		recx = -recx
	var recy = Vector2(0,midpoint.y).distance_to(Vector2(0,mousepos.y))
	if mousepos.y < midpoint.y:
		recy = -recy
	var recpos = Vector2(recx,recy)
	var rpos = recpos/(get_global_transform().origin.distance_to(get_node("camsocket").get_global_transform().origin))

	get_node("recticle").translation = Vector3(rpos.x,get_node("recticle").translation.y,rpos.y)

##Movement
func toggle_flight():#Enables flights for the player
	if is_flying:
		is_flying = false
		speed = landsp
	else:
		is_flying = true
		_on_goup()
		vel.y = 0
		speed = flightsp

func walk(delta):#Moves the object around the world
	if !is_flying:
		vel.y = vel.y - delta
	else:
		if get_node("pin/hoverbuffer/goup").is_colliding():
			_on_goup()
		elif !get_node("pin/hoverbuffer/godown").is_colliding():
			_on_godown()
	var movement = vel*speed
	move_and_slide(movement)

##HOVERING
func _on_goup():
	global_transform.origin.y = global_transform.origin.ceil().y + 1

func _on_godown():
	global_transform.origin.y = global_transform.origin.ceil().y - 1

##PARTS
func loadinparts():
	if parts[0] != "":
		var partable = load(parts[0]).instance()
		add_child(partable)
	if parts[1] != "":
		var partable = load(parts[1]).instance()
		add_child(partable)

##Collision
func _unit_in_com(area):
	var parea = area.get_parent()
	if(parea.is_in_group("unit")):
		if(parea.legiance == playernum):
			units_commandable.append(parea)
			parea.toggle_com_ind()
	elif(parea.is_in_group("decoy")):
		var gparea = parea.get_parent()
		if(gparea.faction == faction):
			if(self.is_in_group("player")):
				units_commandable.append(gparea)

func _unit_out_com(area):
	var parea = area.get_parent()
	if(parea.is_in_group("unit")):
		if(parea.legiance == playernum):
			var findu = units_commandable.find(parea)
			if findu != -1:
				units_commandable.remove(findu)
				parea.toggle_com_ind()
	elif(parea.is_in_group("decoy")):
		var gparea = parea.get_parent()
		if(gparea.faction == faction):
			if(self.is_in_group("player")):
				var findu = units_commandable.find(gparea)
				if findu != -1:
					units_commandable.remove(findu)

func _unit_over(area):
	var parea = area.get_parent()
	if parea.is_in_group("unit"):
		units_pickupable.append(parea)

func _unit_away(area):
	var parea = area.get_parent()
	if parea.is_in_group("unit"):
		var findu = units_pickupable.find(parea)
		if findu != -1:
			units_pickupable.remove(findu)

func _on_colid(area):
	var parea = area.get_parent()
	if parea.is_in_group("projectile"):
		if parea.legiance != playernum:
			set_health(parea.damage)
			parea.queue_free()

##Main
func multiplier():#Multiplies the variables if the multiplier is active
	var multiplier = ProjectSettings.get("Game/Fun/multiplier")
	health = health * multiplier
	maxhealth = health
	healrate = healrate * multiplier
	flightsp = flightsp * multiplier
	landsp = landsp * multiplier

func _physics_process(delta):
	walk(delta)

	gun_handler(delta)
	if is_healing:
		set_health(-healrate)

func _ready():
	add_to_group(gname)
	add_to_group(gname+" faction"+str(faction))

	#Sound
	create_sound()

	#Colid
	pin = get_node("pin")
	clarea = get_node("claw/clarea")

	pin.add_to_group(gname)
	get_node("pin/area").connect("area_entered",self,"_on_colid")

	clarea.connect("area_entered",self,"_unit_over")
	clarea.connect("area_exited",self, "_unit_away")

	var commandarea = get_node("comandarea/carea")
	commandarea.connect("area_entered",self,"_unit_in_com")
	commandarea.connect("area_exited",self,"_unit_out_com")

	#Set up stats
	loadinparts()
	multiplier()
	#Mecha UI
	var inven_lb = get_node("ui_inven/view/grid/label")
	inven_lb.set_text(nickname[0])
	inven_lb.self_modulate = nickname[1]

	#HOVER BUFFER
	#remove collision for area node in player
	get_node("pin/hoverbuffer/goup").collision_mask = 1024
	get_node("pin/hoverbuffer/goup").add_exception(get_node("pin/area"))
	get_node("pin/hoverbuffer/goup").add_exception(get_node("claw/clarea"))
	get_node("pin/hoverbuffer/goup").add_exception(get_node("comandarea/carea"))
	get_node("pin/hoverbuffer/godown").collision_mask = 1024
	get_node("pin/hoverbuffer/godown").add_exception(get_node("pin/area"))
	get_node("pin/hoverbuffer/godown").add_exception(get_node("claw/clarea"))
	get_node("pin/hoverbuffer/godown").add_exception(get_node("comandarea/carea"))
"""
UNIT
"""
extends KinematicBody
###A Object unit for the player
#EXTERNAL HELP
const MATH = preload('res://scripts/MATH.gd')
var multiplier = ProjectSettings.get("Game/Fun/multiplier")
#Description
var gname = "unit"
var legiance = 0 #What player owns the unit
var faction = 0 #What side the unit is on
export var can_capture = false
export var is_turrent = false
export var is_flight = false
export var is_anti_air = false
#Status
export var health = 70
export var speed = 4
export var damage = 35
var gravity = -1
#GUNS
var is_firing = false
var is_gun_ready = true
var gtlimit = 0.4
var gtimer = 0
var gammo = 'res://objects/projectile/projectile.tscn'
#AI
var aim_y = 4
var timer_name = "delaytimer"
var vel = Vector3(0,0,0)
var ai_path = []
var patrol_points = [
Vector3(1,0,0),
Vector3(0,0,1),
Vector3(-1,0,0),
Vector3(0,0,-1)
]
var dir_current = 0
enum ai_behavior_list {
patrol,
turrent,
defend,
seek,
follow,
attack,
destroy #Main base
}
var ai_behavior_act = 2
export var default_behavior = ai_behavior_list.patrol
#In battle
var parent_player = null
var targetobj = null #For ai_behavior, aiming,
var targetbase = null
var list_of_enemies = []
var colid

##Sound
func create_sound():
	var sound = AudioStreamPlayer3D.new()
	sound.name = "sound"
	sound.max_distance = 0
	sound.unit_db = 32
	sound.max_db = 6
	sound.unit_size = 64
	sound.attenuation_model = sound.ATTENUATION_INVERSE_SQUARE_DISTANCE
	add_child(sound)
func play_sound(value):
	if has_node("sound"):
		var sound = get_node("sound")
		var lval = load(value)
		if sound.stream != lval:
			sound.stream = lval
			sound.play(0)
		if !sound.playing:
			sound.play(0)
##Monitoring 
func die():
	queue_free()

func set_health(value):
	health = health - value
	if health < 0:
		die()

func add_command_indicator():
	var sprite = Sprite3D.new()
	sprite.name = "com_ind"
	sprite.set_texture(load('res://assets/sprites/command_indicator.png'))
	sprite.rotation.x = 90
	sprite.scale = sprite.scale * 30
	sprite.visible = false
	add_child(sprite)

func toggle_com_ind():
	if has_node("com_ind"):
		var com_ind = get_node("com_ind")
		if com_ind.visible:
			com_ind.visible = false
		else:
			com_ind.visible = true
	 
##Weapons
func gun_handler(delta):#Handles gun firing
	if is_gun_ready && is_firing:
		fire_gun(str(1),gammo)
		is_gun_ready = false
		gtimer = gtlimit
	elif !is_gun_ready:
		if gtimer < 0:
			is_gun_ready = true
		else:
			gtimer = gtimer - delta

func fire_gun(whatgun,whatammo,gunsound = "res://audio/sounds/blaster.ogg"):#Loads and fires a ammo to a gun
	if get_node("coild/guns").has_node(whatgun):
		whatgun = get_node("coild/guns").get_node(whatgun)
		whatammo = load(whatammo).instance()

		whatammo.set_global_transform(whatgun.get_global_transform())
		whatammo.add_collision_exception_with(self)
		whatammo.legiance = legiance
		whatammo.faction = faction
		get_tree().get_root().add_child(whatammo)

##Movement
func ai_handler(delta):#Handles the AI behavoir
	if ai_behavior_act != ai_behavior_list.turrent:
		if ai_behavior_act == ai_behavior_list.patrol:
			patrolling()
		elif ai_behavior_act == ai_behavior_list.defend:
			if targetobj != null:
				if (typeof(weakref(targetobj).get_ref()) != TYPE_NIL):
					turrentrot(targetobj.get_global_transform().origin)
		elif ai_behavior_act == ai_behavior_list.seek:
			if targetobj != null:
				if (typeof(weakref(targetobj).get_ref()) != TYPE_NIL):
					chase(targetobj.get_global_transform().origin)
				else:
					ai_behavior_act = ai_behavior_list.patrol
		elif ai_behavior_act == ai_behavior_list.follow:
			if parent_player != null:
				if (typeof(weakref(parent_player).get_ref()) != TYPE_NIL):
					chase(parent_player.get_global_transform().origin)
				else:
					ai_behavior_act = ai_behavior_list.patrol
		elif ai_behavior_act == ai_behavior_list.attack:
			if can_capture:
				capture_base()
			else:
				attack_base()
		elif ai_behavior_act == ai_behavior_list.destroy:
			destroy_main_base()
	else:
		if targetobj != null:
			if (typeof(weakref(targetobj).get_ref()) != TYPE_NIL):
				turrentrot(targetobj.get_global_transform().origin)
			else:
				ai_behavior_act = default_behavior

func set_path(start,end):#The path from point A to point B
	if has_node("/root/level/nav"):
		var nav = get_node("/root/level/nav")
		var prev_point = start
		for point in nav.get_simple_path(start,end,true):
			var pceil = point.ceil()
			#If it's not that far from the last point then don't bother adding it in.
			if ((prev_point.x)||(prev_point.x + 1)!=(point.x)||(point.x + 1)):
				if ((prev_point.z)||(prev_point.z + 1)!=(point.z)||(point.z + 1)):
					ai_path.append(pceil)
					prev_point = pceil
			

func check_current_path():#Checks if the path route has been done.
	var gtoc = get_global_transform().origin.ceil()
	if ai_path.size() > 0:
		if ((gtoc.x) == ai_path[0].x):
			if ((gtoc.z) == ai_path[0].z):
				if ai_path.size() > 0:
					ai_path.remove(0)
				if ai_path.size() <= 0:
					set_ai_behavior(2)

func set_patrol_route():#Moves the Decoy in a direction (Changes on timer)
	if ai_behavior_act == 0:#Patrol between a route
		if patrol_points.size() > dir_current: 
			vel = (patrol_points[dir_current])*speed
			if !is_anti_air:
				aim_y = colid.get_global_transform().origin.y
			var targ_no_y = Vector3(vel.x,aim_y,vel.z)
			colid.look_at(targ_no_y,Vector3(0,1,0))
			dir_current = dir_current + 1
			if dir_current >= patrol_points.size(): #Check if the new dir_current is bigger than the list
				dir_current = 0
	#get_node(timer_name).start()#Gets the timer and resets it

func patrolling():
	if !is_flight:
		vel.y = gravity
	move_and_slide(vel)
	if targetbase != null:
		if (typeof(weakref(targetbase).get_ref()) != TYPE_NIL):
			turrentrot(targetobj.get_global_transform().origin)

func turrentrot(target):
	if !is_anti_air:
		aim_y = get_global_transform().origin.y
	var targ_no_y = Vector3(target.x,aim_y,target.z)
	colid.look_at(targ_no_y,Vector3(0,1,0))

func chase(target):#Chases a target (Often a player)
	var tarx = Vector3(get_global_transform().origin.x,0,0).distance_to(Vector3(target.x,0,0))
	if get_global_transform().origin.x < target.x:
		tarx = -tarx
	var tarz = Vector3(0,0,get_global_transform().origin.z).distance_to(Vector3(0,0,target.z))
	if get_global_transform().origin.z < target.z:
		tarz = -tarz

	var dir = (Vector3(-MATH.npz(tarx),0,-MATH.npz(tarz)))*speed
	if !is_flight:
		dir.y = gravity
	move_and_slide(dir)

	if !is_anti_air:
		aim_y = colid.get_global_transform().origin.y
	var targ_no_y = Vector3(target.x,aim_y,target.z)
	colid.look_at(targ_no_y,Vector3(0,1,0))

func find_base():#Finds nearest base
	var tbdis = null
	
	#1st get list of bases and compare their distance.
	if get_tree().get_root().has_node("level/bases"):
		for base in get_tree().get_root().get_node("level/bases").get_children():
			if base.faction != faction:
				var borin = base.get_global_transform().origin
				var bas = borin.distance_to(get_global_transform().origin)
				if tbdis == null:
					tbdis = bas
					targetbase = base
				if bas < tbdis:
					tbdis = bas
					targetbase = base
	else:
		targetbase = targetobj

func destroy_main_base():
	if get_tree().get_root().has_node("level/hq"):
		for h in get_tree().get_root().get_node("level/hq").get_children():
			if h.faction != faction:
				chase(h.get_global_transform().origin)

func attack_base():
	#print("Unit ",targetbase)
	if targetbase != null:
		if (typeof(weakref(targetbase).get_ref()) != TYPE_NIL):
			chase(targetbase.get_global_transform().origin)
	else:
		find_base()

func capture_base():
	if targetbase != null:
		if (typeof(weakref(targetbase).get_ref()) != TYPE_NIL):
			if ai_path.size() <= 0:
				set_path(get_global_transform().origin,targetbase.get_global_transform().origin)
			check_current_path()
			if ai_path.size() > 0:
				chase(ai_path[0])
	else:
		find_base()

func set_ai_behavior(value):
	if ai_behavior_act != ai_behavior_list.turrent:
		if typeof(value) == TYPE_INT:
			ai_behavior_act = value

func get_next_enemy(impobject):
	list_of_enemies.remove(list_of_enemies.find(impobject))
	if list_of_enemies.size() > 0:
		targetobj = list_of_enemies[0]
	else:
		is_firing = false

func set_next_enemy(impobject):
	targetobj = impobject
	list_of_enemies.append(impobject)
	if !is_firing:
		is_firing = true

##MAIN
func _on_hear( area ):
	var parea = area.get_parent()
	if parea.is_in_group("player"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			set_next_enemy(gparea)
	if parea.is_in_group("unit"):
		if parea.faction != faction:
			set_next_enemy(parea)

func _on_silence(area):
	var parea = area.get_parent()
	if parea.is_in_group("player"):
		var gparea = parea.get_parent()
		if gparea.faction != faction:
			if targetobj == gparea:
				get_next_enemy(gparea)
	if parea.is_in_group("unit"):
		if parea.faction != faction:
			get_next_enemy(parea)

func _on_colid(area):
	var parea = area.get_parent()
	if parea.is_in_group("projectile"):
		if parea.legiance != legiance:
			set_health(parea.damage)

func _process(delta):
	ai_handler(delta)

	gun_handler(delta)

func _ready():
	#MULTIPLERs
	health = health * multiplier
	speed = speed * multiplier
	damage = damage * multiplier
	#Add to decoy group
	add_to_group(gname)
	add_to_group(str(legiance)+gname)

	colid = get_node("coild")

	#Set up sensor, area would be the parea of sensor
	get_node("area").connect("area_entered",self,"_on_colid")
	get_node("eye/sensor").connect("area_entered",self,"_on_hear")
	get_node("eye/sensor").connect("area_exited",self,"_on_silence")
	#Sound
	create_sound()
	#UI
	add_command_indicator()
	#Specific parts of the unit
	if is_turrent:
		ai_behavior_act = ai_behavior_list.turrent
	if is_flight:
		colid.translation.y = 4
	#Enable movement
	set_process(true)
	#Set AI direction on start
	set_patrol_route()
"""
MATH
"""
##MATH
func npz(value,rangeof = 1):#Negative, Positive or zero (Only returns a whole 1 or 0)
	if value > rangeof:
		return 1
	elif (value < 1) && (value > -1):
		return 0
	else:
		return -rangeof

 