"""Remember since this node is input_con it control's it's parent"""

extends "res://scripts/AI_entity.gd"
###AI control for mecha.gd and decoy.gd
#command
enum game_modes {DB,DM,ST}
var current_mode = game_modes.DM
var unit_waves = {	"capture_base":[0,0,0,0,1],
					"assult_base":[1,3,7,7,4],
					"Deploy_AA":[2,2,2,6,6],
					"Defensive_wave":[6,6,7,7,3],
					"Flankers":[1,1,5,4,4],
					"Tank_wave":[7,7,7,7,7]}
var drop_spot = null
var wait_timer = 10
var btimer = 0
#Mecha Keyword
var unit_list

## Mecha AI tree functions

func find_gamemode():#Find out what gamemode the map is on.
	if(has_node("/root/level")):
		var level = get_node("/root/level")
		match(level.game_mode):
			(level.game_modes.DB):#Set up the CPU player for a round of destroy base
				if(has_node("/root/level/bases")):
					var bases = get_node("/root/level/bases").get_children()
					objective = find_closest_base(bases,p.global_transform.origin,true) # Look for uncapped bases
				current_mode = game_modes.DB
				set_ai_behavior(AI_State.BUILD)
			_:#If it isn't any other gamemode it must be DM
				set_ai_behavior(AI_State.HUNT)
				current_mode = game_modes.DM
		print("AI Mecha entity: gamemode",current_mode,"level mode:",level.game_mode)

##Building units

func create_units(strategy,delay_time):#Creates waves of units
	wait_timer = delay_time#set the minium time for wait_for_units
	for i in strategy:
		purchase_unit(unit_list[i],i)
	current_step = current_step + 1

func purchase_unit(unit,unitname = "Unknown"):#Buy units for cpu player
	if(p.money > 0):
		p.money = p.money - unit[2]
		var qtimer = Timer.new()
		qtimer.set_wait_time(unit[1])
		qtimer.connect("timeout",self,"qtimer_out",[qtimer,unit[0],unitname])
		qtimer.start()
		add_child(qtimer)

		wait_timer += unit[1]#An addition to the wait timer for the unit's queue time

func qtimer_out(timer,unit,unitname):#The queuetimer for building units.
	p.add_unit_to_list(unit)#When done create unit
	timer.queue_free()#Remove the timer so the game is not flooded with unnuesed Timer nodes.
	emit_signal("_on_unit_built")

##Command

func wait_for_units(delta):#Depending on the time set. Wait till units are done being made
#	print("ai_mecha_entitiy: ", wait_timer,p.mecha_unit_ready_list)
	if(wait_timer < 0):
#		print("mecha ai is over base",p.is_over_base)
		if(p.is_over_base):
			if(p.mecha_unit_ready_list.size() <= 0):
				current_step = current_step + 1
			else:
				p.pickup_unit(p.mecha_unit_ready_list[0])
				p.mecha_unit_ready_list.remove(0)
		else:#If it needs to be over base
#			print("ai_mecha_entity"," Help not over base.")
			if(p.is_over_land == false):#If it is over a unncapped base, then try getting a new base that is capped.
				get_current_base(0)
			else:
#				print("ai_mecha_entity"," chasing base:",current_base)
				chase(current_base)
	else:
		wait_timer = wait_timer - delta

func direct_to(to,from,offset = 7):#Finds a position between two bases.
	#this is suppose to be 7 distance away from the base toward the target base
	var msydis = (to.distance_to(from) - offset)
	var t = msydis/to.distance_to(from)
	
	var mslope = Vector2((to.x - from.x),(to.y - from.y))
	var intercepty = Vector2()
	var xcord = ((1-t)*mslope.x)
	var ycord = ((1-t)*mslope.y)
	var local = Vector3(xcord,0,ycord)
	print("AI_Mecha:",msydis," -- ",local," -- ",to," -- ",from," -- ",mslope," -- ",msydis," -- ",to.distance_to(from))
	return local

func find_drop_spot(location = current_base, offset = Vector3(8,0,0)):#Find a place to drop the carried units.
	if(drop_spot == null):
		drop_spot = location.ceil() + offset

	chase(drop_spot)
	var gtoc = p.global_transform.origin.ceil()
	#print(gtoc,drop_spot)
	if(does_vceil_match(gtoc.ceil(),drop_spot.ceil())):
		if(p.inventory.size() > 0):
			p.drop_unit(p.inventory[0])
			p.inventory.remove(0)
			drop_spot = drop_spot + Vector3(2,0,0)
		elif(p.inventory.size() == 0):
			drop_spot = Vector3(current_base.ceil().x + 8,0,drop_spot.z + 3)
			current_step = current_step + 1

## Battle sub-routines

func check_battle_status(delta):#After certain amout of time, determine next move AKA Repeat process
	#This should check if snenario
	btimer = btimer - delta
	if(btimer < 0):
		current_step = 0

func find_unit(type):#Finds a units, and targets it
	#Type 0 is friendly, Type 1 is enemy
	if(get_tree().get_root().has_node("level/units")):
		for i in get_tree().get_root().get_node("level/units").get_children():
			if((i.faction == p.faction) && (type == 0)):
				objective = i
			elif((i.faction != p.faction) && (type == 1)):
				objective = i

##Main
func _ready():
	unit_list = p.unit_list
	find_gamemode()
	add_user_signal("_on_unit_built")
	get_current_base(0)

	add_to_group("player faction"+str(faction))
	add_to_group("mecha_ai")

	print("Mecha AI", faction, p.faction)