"""Remember since this node is input_con it control's it's parent"""

extends "res://scripts/AI_entity.gd"
###A commandable object of mecha.gd

##AI
func patrolmode(delta):
	match(current_step):
		(0):
			create_patrol()
			create_path(patrol_points[0],patrol_points[1])
			current_step += 1
		(1):
			chase(patrol_points[0])
			if(does_vceil_match(p.global_transform.origin.ceil(),patrol_points[0].ceil(),7)):
				current_step = 2
		(2):
			chase(patrol_points[1])
			if(does_vceil_match(p.global_transform.origin.ceil(),patrol_points[1].ceil(),7)):
				current_step = 1

func huntmode(delta):
	match(current_step):
		(0):
			for player in get_tree().get_nodes_in_group("player"):
				if(player.is_class("KinematicBody")):
					if(player.playern != p.playern):
						objective = player
						break
		(1):
			chase(objective.global_transform.origin)

func followmode(delta):
	match(current_step):
		(0):
			if(parent_player != null):
				if(weakref(parent_player).get_ref()):
					objective = parent_player
		(1):
			if(weakref(objective).get_ref()):
				var gtoc = p.global_transform.origin.ceil()
				chase(ai_path[0])
				create_path(objective.global_transform.origin,gtoc)
			else:
				current_step = 0

func destroymode(delta):
	match(current_step):
		(0):
			if(has_node("/root/level/hq")):
				var bases = get_node("/root/level/hq")
				objective = find_closest_base(bases.get_children(),p.global_transform.origin,1)
			create_path(p.global_transform.origin,objective)
			current_step += 1
		(1):
			chase(objective)
			aim(objective)

func attackmode(delta):#also used for capturing bases
	match(current_step):
		(0):
			if(has_node("/root/level/bases")):
				var bases = get_node("/root/level/bases")
				objective = find_closest_base(bases.get_children(),p.global_transform.origin,1)
			create_path(p.global_transform.origin,objective)
			current_step += 1
		(1):
#			print("Hey here is this unit's ai_path:",ai_path)
			if(ai_path.size() > 0):#If the AI actually has a path.
				chase(ai_path[0])
			else:
				pass
				print("Hey here is this unit's ai_path:",ai_path)

func turrentmode(delta):
	match(current_step):
		(0):
			stop()
			if(target_enemy != null):
				current_step = 1
		(1):
			if(weakref(target_enemy).get_ref()):
				aim(target_enemy.global_transform.origin)
			else:
				current_step = 0

##Main
func ai_handler(delta):#Handles the AI behavoir
	if((current_state != AI_State.TURRENT)&&(p.unitmode != p.unit_type.TURRENT)):
		match(current_state):
			(AI_State.BUILD):#Though this means build for mecha based units for the norm it's PATROL
				patrolmode(delta)
			(AI_State.DEFEND):
				turrentmode(delta)
			(AI_State.HUNT):
				huntmode(delta)
			(AI_State.FOLLOW):
				followmode(delta)
			(AI_State.ATTACK):
				attackmode(delta)
			(AI_State.DESTROY):
				destroymode(delta)
	else:
		turrentmode(delta)

func _ready():
	#Add to unit group
	p.add_to_group(p.gname)
	p.add_to_group(str(p.playern)+p.gname)