extends RigidBody
###An object that acts like a mid point for players.
var gname = 'base'
export var faction = 0 #0 = Undecided, 1 = team 1, 2 = team 2
export var cap_size = 4 #For changing the size of the cappoints
export(Color) var skin = Color("909090")
var cappoints = []#How many things need to cap this base before it becomes appart of their side

var is_capturable = true

export(bool) var can_heal = true
export(bool) var can_spawn_units = true

export var money_value = 100 
export var money_time_limit = 1

##Capture
func check_cappoints(new_cap,skins):#Checks if the player has captured it.
	#1.Send signal to CPU player that a base other their's is under attack
	get_tree().call_group("player"+str(faction),"form_plan",self,2)
	#2. Then check caps
	var i = 0
	for point in cappoints:
		if(point != new_cap):
			var progress = get_node("ui_capturepoint/view/progress")
			var faccap = get_node("ui_capturepoint/view/faccapping")
			cappoints[i] = new_cap
			progress.value = i+1
			faccap.text = str(new_cap)
			print("base.gd: ",cappoints," hye",i)
			if(cappoints[cappoints.size()-1] == new_cap): #If the last point matches the faction. Then it is captured.
				faction = new_cap
				set_base_color(skins)
			else:
				return#If one of the cappoints don't line up, don't bother looking at the rest.
		i = i + 1

	print("base.gd: ",cappoints," hye")

	if(get_tree().network_peer != null):#If network play send data to the other clients
		rpc_unreliable("update_base_status",cappoints,faction)

slave func update_base_status(cap,fac):#For network play. Sends the data of the base's state of being.
	cappoints = cap
	faction = fac

## Timer
func create_mtimer(functioned,mv):#For money or resource interval
	#mv = money value
	if(has_node("mtimer")):#if a mtimer already exists, no need in making a new one.
		var mtimer = get_node("mtimer")
		mtimer.connect("timeout",self,functioned,[mv])
	else:
		var mtimer = Timer.new()
		mtimer.name = "mtimer"
		mtimer.set_wait_time(money_time_limit)
		mtimer.connect("timeout",self,functioned,[mv])
		mtimer.start() 
		add_child(mtimer)

func _on_money_interval(value):
	get_tree().call_group("player faction"+str(faction),'set_money',-value)#It is negative, because the function subtracts, In short double negative = positive.

## UI
func set_base_ui(icon, value):
	get_node("ui_capturepoint/view/icon").frame = icon
	get_node("ui_capturepoint/view/icon/valued").text = str(value)

func set_base_color(skins):#Sets the color of the base.
	skin = skins
	if(has_node("Scene Root")):
		var mesh = get_node("Scene Root").get_child(0)
		if(is_instance_valid(mesh)):
			var modmat = ShaderMaterial.new() #Modulation material
			var shader = Shader.new()
			var rgb = str(skins.r)+","+str(skins.g)+","+str(skins.b)
			shader.code = "shader_type spatial;void fragment() {ALBEDO = vec3("+rgb+");}"
			modmat.shader = shader
			mesh.set_surface_material(0,modmat)

## Main
func _on_colid(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(parea.name == "pin"):#Other nodes that do not relate to pim/area (I.E Sensors) should not trigger base's collision
		if(gparea.is_in_group('player') || gparea.is_in_group("decoy")):
			if(gparea.faction == faction):
				gparea.is_over_base = can_spawn_units
				gparea.is_over_land = false
				gparea.is_healing = can_heal
				if(gparea.is_in_group("player")):
					get_tree().call_group("player_ui"+str(gparea.trackingn),"toggle_shop",true)
		if(gparea.is_in_group('unit')):
			if((gparea.unitmode == gparea.unit_type.CAPTURE) && is_capturable):
				if(gparea.faction != faction):
					check_cappoints(gparea.faction,gparea.skin)
					gparea.queue_free()

func _on_leave(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group('player') || gparea.is_in_group("decoy")):
		gparea.is_over_base = false
		gparea.is_over_land = true
		gparea.is_healing = false
		if(gparea.is_in_group("player")):
			gparea.emit_signal("_on_over_base")

func _ready():
	add_to_group(gname)

	set_base_color(skin)

	for i in cap_size:
		cappoints.append(0)

	get_node("area").connect("area_entered",self,"_on_colid")
	get_node("area").connect("area_exited",self,"_on_leave")

	#Multiplier
	var multiplier = ProjectSettings.get("Game/Fun/multiplier")
	money_value = money_value * multiplier

	#For money interval
	create_mtimer("_on_money_interval",money_value)
