extends Control
###This is the campaign map for single player.
const LEVELRES = preload("res://scripts/levelres.gd")
const INVRES = preload("res://scripts/inventoryres.gd")
const MS = preload("res://scripts/match_setting.gd")

var match_settings = null
var is_scrolling = false

func toggle_match_lobby(country_settings):#Toggles the match lobby
	var scene = "res://ui/match_lobby.tscn"
	var namescene = "match_lobby"
	if(has_node(namescene)):
		var ml = get_node(namescene)
		ml.queue_free()
		get_node("themap/bg").visible = true#Reshow the background and all the clickable countries
		get_node("info").visible = true
	else:
		#print("campaign: country setting - ",set_up_country_setting(2,[american_mecha,ru_mecha]).players)
		var ml = load(scene).instance()
		ml.lobby_mode = ml.lobbytype.STORY
		add_child(ml)#This must be done first because some stuff must be loaded in on ready
		ml.unchangable = true
		ml.set_match_settings(country_settings)# This also sets up the UI in the lobby. Not just the data.
		get_node("themap/bg").visible = false#Hid bg so the buttons will not work over the match lobby ones.
		get_node("info").visible = false

func set_up_country_setting(level,players):
	var coun = MS.new()
	var levres = LEVELRES.new()
	coun.mode = 2 #WE know the mode is going to be story mode, 2 = ST
	coun.level = levres.get_level_res()[level][0]
	coun.players = players
	coun.music = levres.get_level_res()[level][1]
	return coun

## Data Management
func save_campaign():
	var file = File.new()
	file.open("user://campaign_data.dat",File.WRITE)
	file.store_var(match_settings)
	file.close()
	print("hey you campaign map save",file.get_path())

func load_campaign(dat):#Load in a json for the campaign map.
	var file = File.new()
	if(file.file_exists(dat)):
		print("campaignmap.gd: ",dat)
		get_tree().call_group("menu","reprint",("Campaign is loading mapdata - "+str(dat)))
		file.open(dat, File.READ)
		print("Campaign map: hey a dat file exists")
		match_settings = file.get_var()
		file.close()
	else:
		get_tree().call_group("menu","reprint",("Campaign is starting new game"))
		# set up match settings, a setting will be seperate for each country 
		var invres = INVRES.new()
		var ep_uni = [invres.get_units()["mimic"],invres.get_units()["motor"],invres.get_units()["bazooka"],invres.get_units()["turrent"],invres.get_units()["airplane"],invres.get_units()["jeep"],invres.get_units()["antiair"],invres.get_units()["tank"],]
		var ms = MS.new()
		var american_mecha = ms.add_player_setting("res://scripts/player.gd", invres.get_mechas()["Prototype"][0], invres.get_decoys()["decoy7"], ep_uni, [invres.get_parts()["NONE"],invres.get_parts()["NONE"]], [invres.get_weapons()["basic"],invres.get_weapons()["missle launcher"]], 1, ["American","0000ff"], 1, 0)
		var ru_mecha = ms.add_player_setting("res://scripts/stupid_AI.gd", invres.get_mechas()["Prototype"][0], invres.get_decoys()["decoy7"], ep_uni, [invres.get_parts()["NONE"],invres.get_parts()["NONE"]], [invres.get_weapons()["basic"],invres.get_weapons()["missle launcher"]], 2, ["Russian","ff0000"], 1, 0)
		
		#A easy int list for level select (For those that wonder why level select isn't a dictionary, it's because match_lobby.gd's form_level_select() uses the array instead of a dictionary. [THAT PROBLEY SHOULD BE CHANGED.]) 
		#0. DM_test
		#1. DB_test
		#2. DB_cliffside
		#3. DB_labyrinth
		#4. DEMO
		match_settings = {	"USA":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Mexico":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Cuba":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Egreenland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ngreenland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sgreenland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Wgreenland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Canada":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Windsor":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Islandnf":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Queenislands":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ncanada":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Novascot":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ealaska":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Walaska":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Salaska":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Florida":set_up_country_setting(2,[american_mecha,ru_mecha]),
	##Europe
							"Iceland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Faroe_Islands":set_up_country_setting(1,[american_mecha,ru_mecha]),
							"Jan_Mayen":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"UK":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ireland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Switzerland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Italy":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Italy_Sicily":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"France":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Belgium":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Spain":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Portugal":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Denmark":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Neitherlands":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Germany":set_up_country_setting(3,[american_mecha,ru_mecha]),
							"Czech":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Austria":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Poland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"North_vikingland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Norway":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sweden":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Finland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"West_russia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Lithuania":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Latvia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Estonia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Belarus":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ukraine":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Slovakia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Hungary":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Croatia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Romania":set_up_country_setting(2,[american_mecha,ru_mecha]),#Maybe this map could focus on Vlad the "I'm-gonna-stick-it-to-ya" 'S castle
							"Moldova":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Bosnia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Serbia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Macedonia_Albania":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Greece_west":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Greece_east":set_up_country_setting(2,[american_mecha,ru_mecha]),
	##South America
							"Colombia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Venezuela":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Guyana":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Suriname":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"French_guiana":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Brazil":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Rio_grande":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Bolivia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Peru":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ecuador":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Paraguay":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Argentina":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"East_argentina":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Chile":set_up_country_setting(2,[american_mecha,ru_mecha]),
	##Africa
							"South_africa":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Lesotho":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Namibia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Botswana":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Zimbabwe":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Mozambique":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"South_madagascar":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"North_madagascar":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Angola":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Zambia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Malawi":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Tanzania":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Congo":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Uganda":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Kenya":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"West_congo":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Gabon":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Somalia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ethiopia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"South_sudan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sudan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Egypt":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Cameroon":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Central_africa":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Chad":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Eritrea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Libya":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Niger":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Nigeria":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Tunisia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Algeria":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Benin":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Burkina_faso":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ghana":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ivory_coast":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Liberia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Guinea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Mali":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sierra_leone":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Senegal":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Mauritania":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Western_sahara":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Morocco":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Canary_islands":set_up_country_setting(2,[american_mecha,ru_mecha]),
	#Oceania
							"Australia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Queensland":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Tasmania":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"New_zealand":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Papua_new_guinea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"New_guinea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Java":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sumatra":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sulawesi":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Kalimantan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Malaysia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Philippines":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Singapore_malaysia":set_up_country_setting(2,[american_mecha,ru_mecha]),
	## ASIA
							"Japan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Hokkaido":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sakhalin":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Russia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"South_Russia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"South_Korea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"North_Korea":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"China":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Mongolia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Assam":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Bangladesh":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Nepel":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Burma":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Thailand":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Cambodia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Vietnam":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Laos":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Kazakhstan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"India":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Sri_Lanka":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Novaya_Zemlya":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Svalbard":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Severnaya_Zemlya":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Franz_Josef_land":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Wrangle_island":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"new_Siberian_Islands":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Uzbekistan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Tajikistan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Kyrgyzstan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Pakistan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Afghanistan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Turkmenistan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Iran":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Yemen":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Oman":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Arab_Emirates":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Saudi_Arabia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Israel_Jordan":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Iraq":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Syria":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Turkey":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Armenia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Georgia":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Azerbaijan":set_up_country_setting(2,[american_mecha,ru_mecha]),
	##Antarctica
							"Shetland_island":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Argentina_Antarctica":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"British_Antarctica":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ellsworth_Vinson_massif":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Marie_Byrd_land":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Queen_muad_land":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Australia_Russian_Antarctica":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"French_Claim":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"east_australia_antarctica":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"Ross_iceshelf_NZ":set_up_country_setting(2,[american_mecha,ru_mecha]),
							"South_pole_Amundsen_scott":set_up_country_setting(2,[american_mecha,ru_mecha])
							}

	#Set up the country buttons 
	var themap = get_node("themap")
	var bg = themap.get_node("bg")
		
	for country in bg.get_children():
		if(country.is_class("TextureButton")):
			country.connect("pressed",self,"toggle_match_lobby",[match_settings[country.name]])#if this is crashing it's cause a country is missing from the match_settings


##Movement
func _input(event):
	var themap = get_node("themap")
	if(event.is_class("InputEventMouseButton")):#Zoom in and out
		var zoompercent = (event.factor/8)
		match(event.button_index):
			BUTTON_WHEEL_UP:
				get_node("themap/bg").rect_scale.x += zoompercent
				get_node("themap/bg").rect_scale.y += zoompercent
			BUTTON_WHEEL_DOWN:
				get_node("themap/bg").rect_scale.x -= zoompercent
				get_node("themap/bg").rect_scale.y -= zoompercent
			BUTTON_RIGHT:
				if(event.pressed):
					is_scrolling = true
				else:
					is_scrolling = false
	elif(event.is_class("InputEventMouseMotion")):
		if(is_scrolling):
			print("campaign map",is_scrolling,event.relative)
			themap.scroll_horizontal += event.relative.x
			themap.scroll_vertical += event.relative.y


##MAIN
func _ready():
	load_campaign("user://campaign_data.dat")#$HOME/.godot/app_userdata/DUKE (|| on Steam) $HOME/.local/share/godot/app_userdata

	get_node("info/data_management/save").connect("pressed",self,"save_campaign")
	get_node("info/data_management/load").connect("pressed",self,"load_campaign")