extends MeshInstance
export(String, FILE) var gammo = "res://objects/projectile/bullet.tscn"
export(String, FILE) var gsound = "res://assets/audio/sounds/laser-ozzy.ogg"
export(int) var gt_limit = 1
var gun_ready = true
var gun_timer = 0

const MULTIPLIER = 8

slave func play_sound(value):#Play a sound
	var lval = load(value)
	if(has_node("sound")):
		var sound = get_node("sound")
		if(lval != null):
			if(lval.is_class("AudioStreamOGGVorbis")):
				lval.loop = false
			if(sound.stream != lval):
				sound.stream = lval
				sound.play()
			if(!sound.playing):
				sound.play()
		else:
			sound.playing = false

func create_sound():#Create the node to play sound
	var sound = AudioStreamPlayer3D.new()
	sound.name = "sound"
	sound.max_distance = 0
	sound.unit_db = ProjectSettings.get("Game/Options/sound_volume")
	sound.max_db = 6
	sound.unit_size = 16
	sound.attenuation_model = sound.ATTENUATION_INVERSE_SQUARE_DISTANCE
	add_child(sound)

slave func fire_gun(playern,faction):#Fires the weapons
	if(gun_ready):
		var gammotion = load(gammo)
		if(gammo != null):
			gammotion = gammotion.instance()
		for pos in get_children():
			if(pos.is_class("Position3D")):
				if(typeof(weakref(gammotion).get_ref()) != TYPE_NIL):
					gammotion.set_global_transform(pos.global_transform)
					gammotion.add_collision_exception_with(self)
					gammotion.playern = playern
					gammotion.faction = faction
					get_tree().get_root().add_child(gammotion)

					play_sound(gsound)

		gun_ready = false
		gun_timer = gt_limit
	
	if(get_tree().has_network_peer() && (is_network_master())):#If online fire the gun on the other players' screen
		rpc_unreliable("fire_gun",playern,faction)

func cool_down(delta):#Count downs if the gun is ready to fire.
	gun_timer -= (delta*MULTIPLIER)
	if(gun_timer <= 0):
		gun_ready = true

func _physics_process(delta):
	if(gun_ready == false):
		cool_down(delta)

func _ready():
	create_sound()