extends CanvasLayer
#Description
var gname = "hud"
#Player status
var players_active = [0,0,0,0] #How many players are currently playing #0 = inactive,1=active
#^ Uh oh, This does not work if the player number is the same.
var pstats

var prev_music = "res://assets/audio/music/ogg/2fm.ogg"

#controls
var player_control_type = [0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]#Hmmm it seams the options menu doesn't change this.

##Start Match
func create_match(match_settings,is_online):#This should be called set up match or create match as that's what it does
	gameover()#End the current match if any.

	s_play_music(match_settings["music"])#Change music to level's theme.

	get_tree().call_group("level","set_game_mode",match_settings["mode"])#Set the match's gameplay mode

	players_active = []
	var trackingn = 0
	while trackingn < match_settings.players.size():
		players_active.append(1) #for every player that is going to be in the match, 1 = active
		var id = 1 #For network play. 
		if(match_settings.players[trackingn]["input_con"] == "res://scripts/player.gd"):#If it's a human player spawn in a vcon.
			#Set up vcons
			var vcon = load("res://ui/vcon.tscn").instance()
			var play_ui = load("res://ui/player_ui.tscn").instance()
			if(get_tree().has_network_peer()):
				id = get_tree().get_network_unique_id()# This is soley for setting a vcon on the screen of the player/client.
#				print("hud: id ",id,"ddd",match_settings["nickname"][playern])
			print(match_settings.players[trackingn]["nickname"])
			if((is_online == false) || ((is_online == true) && ((match_settings.players[trackingn]["nickname"][0] == str(id)) || (match_settings.players[trackingn]["nickname"][0] == ("(HOST)"+str(id))) ) )):
				play_ui.name = "player_ui"+str(trackingn)
				play_ui.trackingn = trackingn
				vcon.add_to_group(str(trackingn)+"vcon")
				get_node("views").add_child(vcon)
				pstats.add_child(play_ui)

		spawn_players(match_settings.players[trackingn],trackingn,id)
		trackingn += 1

func spawn_players(player_settings,trackingn,player_id = 0):#Grab a spawn point that matches each player's faction. And spawn a player there.
	if(has_node("/root/level/hq")):
		for spawnnode in get_node("/root/level/hq").get_children():
			if(spawnnode.is_in_group("spawn"+str(player_settings["p_faction"]))):
				spawnnode.spawn_new(spawnnode,player_settings,trackingn)

##End Game
sync func set_victory(playnum,value):
	if(value):
		get_tree().change_scene_to(load("res://objects/elements/victory_potem.tscn").instance())
		s_play_music("res://assets/audio/music/ogg/Deflemask_Let_us_Celebrate.ogg")
		var victory = get_node("victory")
		victory.set_visible(true)
		victory.set_text("Player: "+str(playnum + 1)+" WINS!")
		#Set up timer
		var timer = get_node("timer")
		timer.set_wait_time(3)
		timer.connect("timeout",self,"return_main")
		timer.start()
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)

func check_victory():#Checks the game for number of players in game
	print('checking victory')
	var NoAP = 0 #Number of active players
	var champion = 0
	var cur_p = 0
	for iap in players_active:
		if(iap != 0):
			champion = cur_p#This should do nothing if another player is in NoAP
			NoAP = NoAP + 1
		cur_p = cur_p + 1

	if(NoAP <= 1):#if there is only one player left
		if(get_tree().network_peer == null):#If local play just activate the function
			set_victory(champion,true)
		else:#If it's online rpc call it. That way it will be deployed in sync on each player's screen
			rpc("set_victory",champion,true)

func player_died(playern):#When A player has no more lives
	players_active[playern] = 0
	check_victory()

##Sound
func s_set_music_volume():
	var music = get_node("music")
	music.volume_db = ProjectSettings.get("Game/Options/music_volume")
func s_set_announcer_volume():
	var announcer = get_node("announcer")
	announcer.volume_db = ProjectSettings.get("Game/Options/Game/Options/music_volume")
func s_sound_announcer(string_file):
	var announcer = get_node("announcer")
	announcer.set_stream(load(string_file))
	announcer.play(0)
func s_play_music(string_file):
	var music = get_node("music")
	music.set_stream(load(string_file))
	music.play(0)

func toggle_menu():#Toggles the main menu.
	if(!has_node("main")):
		if(get_node("music").stream != null):
			prev_music = get_node("music").stream.resource_path
		s_play_music("res://assets/audio/music/ogg/arp thing.ogg")
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
		if(!get_tree().has_network_peer()):
			get_tree().set_pause(true)
		add_child(load("res://ui/main.tscn").instance())
		get_node("chat").pause_mode = PAUSE_MODE_STOP
	else:
		s_play_music(prev_music)
		Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
		get_tree().set_pause(false)
		get_node("main").queue_free()
		get_node("chat").pause_mode = PAUSE_MODE_INHERIT

##UI
func set_player_active(string_name):#Enables a player's hud
	if(self.has_node(string_name)): #To prevent a crash if the player's ui does not exist
		var player_ui = get_node(string_name) #gets the control node with the same name as the player
		player_ui.set_hidden(false)

##Dialog
func dialogbox(text = "Error!", placement = Rect2(850,190,200,160)):#Displays the dialog box with a new set of text.
	var dialog = get_node("dialog")
	var dtext = dialog.get_node("dtext")

	dtext.text = text
	dialog.popup(placement)

##Level change

func gameover():#Resets everything
	toggle_menu()
	get_node("victory").visible = false
	players_active = [0,0,0,0]
	for ch in get_node("views").get_children():
		ch.queue_free()
	for ch in pstats.get_children():
		ch.queue_free()

func return_main():#Returns to the main menu
	var timer = get_node("timer")
	timer.stop()
	gameover()

##Main
func _input(event):#Used only to activate the main menu
	if(event.is_action_pressed("ui_cancel")):
		toggle_menu()

func _ready():
	#Make the scene callable by group
	add_to_group(gname)

	pstats = get_node("pstats")