extends Spatial
var gname = "level"
enum game_modes {	DB,#Destory Base
					DM,#Death Match
					ST#Story mode 
					}
export(game_modes) var game_mode = 1
export(bool) var has_nav = true 

func set_game_mode(value):
	if(typeof(value) == TYPE_INT):
		if(game_modes.size() >= value):
			game_mode = value
			get_tree().call_group("spawn","detect_game_mode")
			get_tree().call_group("mecha_ai","find_gamemode")#Calls the Mecha AI to change it's protocal.

func create_nav():
	if(has_node("nav")):
		var nav = get_node("nav")
		for i in nav.get_children():
			if(i.is_class("Spatial")):
				for j in i.get_children():
					if(j.is_class("MeshInstance")):
						j.create_trimesh_collision()
						for k in j.get_children():
							if(k.is_class("StaticBody")):
								k.collision_mask = 1025
								k.collision_layer = 1025
						var navimesh = NavigationMeshInstance.new()
						navimesh.navmesh = j.mesh
						j.add_child(navimesh)

func check_hov_collision():#Make sure the terrian is set up for mecha's hover
	#1025 is the collison number for hover to be able to read it.
	if(has_node("nav")):
		var nav = get_node("nav")
		var navsp = nav.get_child(0)
		if(navsp.is_class("Spatial")):
			for mesh in navsp.get_children():
				if(mesh.is_class("MeshInstance")):
					for stbody in mesh.get_children():
						if(stbody.is_class("StaticBody")):
							stbody.collision_mask = 1025
							stbody.collision_layer = 1025

func _ready():
	add_to_group(gname)
	if(!has_nav):
		create_nav()
	name = "level"#All levels should have their names be this way for AI finding the nav node.

	check_hov_collision()

	#ensure the level has a node for units and decoys
	var placeunit = Spatial.new()
	placeunit.name = "units"
	add_child(placeunit)