extends GridContainer
###The lobby of starting a match, This where players adjust their settings to prepare for the fight.
enum lobbytype { LOCAL,QP,LAN,STORY}
export(lobbytype)var lobby_mode = lobbytype.LOCAL

## MATCH SETTINGS DICTIONARY WILL BE REPLACED WITH MATCH SETING CLASS ##
var match_settings = null

const LEVELRES = preload("res://scripts/levelres.gd")
var L
const INVRES = preload("res://scripts/inventoryres.gd")
var MS = preload("res://scripts/match_setting.gd")
var gname = "match_lobby"
var unchangable = false

##Level
func form_level_select():#Forms a selection of levels
	for i in L.get_level_res():
		get_node("selection/sel/levelselect").add_item(i[0])
	for j in L.get_mode_res():
		get_node("selection/sel/modeselect").add_item(j)

master func send_match_settings():#Sends data to the clients
	rpc("set_match_settings",match_settings) 

slave func set_match_settings(new_settings):#This is for sending the match_settings information from the server to the client.
#This is also used when a preselect match setting is used (AKA campaign map)
	match_settings = new_settings
	get_node("selection/sel/modeselect").clear()
	get_node("selection/sel/modeselect").add_item(L.get_mode_res()[match_settings.mode])
	get_node("selection/sel/levelselect").clear()
	get_node("selection/sel/levelselect").add_item(match_settings.level)
	get_node("match_players/numofmatch").value = match_settings.players.size()
	for player in match_settings.players.size():
		create_player_entry(match_settings.players[player]["playern"],match_settings.players[player]["p_faction"]) #I don't know why but Godot is unhappy when I try to use the player array instead of the size

remote func remove_match_setting(playern):#This removes a player froms the match settings
	print("match lobby, disconnect works")
	match_settings.players.remove(playern)

	var mplay = get_node("match_players/scroll_num_players/num_mplayers")#Displays the change to the player entry
	mplay.get_child(playern).get_node("CheckBox").select(0)

remote func add_match_setting(input_con,p_faction,thenick = ["Player"+str(1),"0000ff"],theid = 1):#The adds a player to the match settings
	var playern = match_settings.players.size() #For who gets what control scheme, The player Number would be the current size of the match_settings.

	var invres = load("res://scripts/inventoryres.gd").new()
	var theparts = [invres.get_parts()["NONE"],invres.get_parts()["NONE"]]
	var theweapons = [invres.get_weapons()["basic"],invres.get_weapons()["basic"]]

	var theunits = []
	var nameunits = ["mimic","motor","bazooka","tank","airplane","jeep","antiair","tank"]
	var cur_nam = 0
	for nu in nameunits:
		var cu = invres.get_units()[nu]
		cu.append(nu)
		theunits.append(cu)
		cur_nam += 1

	match_settings.players.append(match_settings.add_player_setting(input_con, invres.get_mechas()["Prototype"][0], invres.get_decoys()["decoy7"], theunits, theparts, theweapons, p_faction, thenick, theid, playern))
#	print("match lobby match setting",match_settings.players)

	if(get_tree().has_network_peer()):#Option only on multiplayer.
		var mplay = get_node("match_players/scroll_num_players/num_mplayers")#Displays the change to the player entry
		for i in mplay.get_children():
			if(i.playern == playern):
				i.get_node("mecha/player_dat/controller").select(2)

	print("match lobby match setting",match_settings.players[0])

remote func create_player_entry(playern,factionn):#Add a new player toggle and inventory, for a new player.(Hud not background stuff.)
	var mplay = get_node("match_players/scroll_num_players/num_mplayers")
	var mpsetup = load("res://ui/mplay_setup.tscn").instance()
	var checkbut = mpsetup.get_node("mecha/player_dat/controller")
	var factionbox = mpsetup.get_node("mecha/player_dat/faction")
	checkbut.select(2)
	checkbut.disabled = unchangable
	factionbox.value = factionn
	factionbox.editable = !unchangable
	mplay.add_child(mpsetup)

	#Now make sure the match settings is updated.
	if(!unchangable):
		checkbut.connect("item_selected",self,"m_on_players_change",[playern])
		factionbox.connect("value_changed",self,"m_on_play_fact_change",[playern])
		add_match_setting("res://scripts/player.gd",factionn,["Player"+str(playern+1),"0000ff"])

func reset_player_entries():#Clear out the players, to make room for a new set of entries.
	var mplay = get_node("match_players/scroll_num_players/num_mplayers")
	for mpchild in mplay.get_children():
		mpchild.queue_free()
	match_settings.players = []
	print("Match_lobby.gd: Player entries reseted")

remote func m_on_player_amount_change(value):#Issue this does not effect the player count on the server.
	if(lobby_mode == lobbytype.LAN):
		unchangable = true
	#First clear out old settings
	if(has_node("match_players/scroll_num_players/num_mplayers")):
		var nom = get_node("match_players/numofmatch")
		reset_player_entries()
		#Second replace with new amount of players
		nom.value = value
		var pfaction = 1
		for but in value:
			L = LEVELRES.new()
			match_settings.level = L.get_level_res()[0][0]
			match_settings.mode = L.get_mode_res()[0]

			create_player_entry(but,pfaction)

			if(pfaction == 1):
				pfaction = 2
			else:
				pfaction = 1

		if(unchangable):
			nom.editable = !unchangable

remote func m_on_play_fact_change(value,playern):#When a faction for a selected player is changed
	match_settings.players[playern]["p_faction"] = value

remote func m_on_players_change(value,playern):#Change the Control type to Human or CPU.
	print("Match_lobby, Changing player input",value)
	match(value):
		0:#Inactive
			match_settings.players[playern]["input_con"] = ""
		1:#OLD CPU
			match_settings.players[playern]["input_con"] = "res://scripts/CPU_player.gd"
		2:#Player
			match_settings.players[playern]["input_con"] = "res://scripts/player.gd"
		3:#Stupid AI
			match_settings.players[playern]["input_con"] = "res://scripts/stupid_AI.gd"

remote func m_on_level_change(indx):
	match_settings.level = L.get_level_res()[indx][0]
	print("match lobby ", L.get_level_res()[indx][1])
	match_settings.music = L.get_level_res()[indx][1]
remote func m_on_mode_change(indx):
	match_settings.mode = indx

func m_on_begin_match():#Start the match
	match(lobby_mode):
		(lobbytype.LOCAL):#If the match is only on this computer. Then start the match locally.
			if(get_tree().network_peer != null):#If the game is in an online match stop it
				get_tree().network_peer = null
				get_tree().call_group("menu","toggle_disconnect")
			begin_match()
		(lobbytype.QP):#If it's just Quick play, then save settings to the quick play settings.
			if(get_tree().network_peer != null):#If the game is in an online match stop it
				get_tree().network_peer = null
				get_tree().call_group("menu","toggle_disconnect")
			get_tree().call_group("menu","set_qp",match_settings)
			get_tree().call_group("menu","toggle_ml_settings",lobby_mode)
		(lobbytype.LAN):#If it's a LAN match start a lan game.
			get_tree().call_group("menu","reprint","Server: Match starting")
			if(get_tree().is_network_server()):#Start match
				begin_match()
				rpc_unreliable("set_match_settings",match_settings)#send information of the match_settings to other players
			rpc_unreliable("begin_match")#Send a message to the other player's lobbies that a match has started
		(lobbytype.STORY):#Campaign event/battle
			if(get_tree().network_peer != null):#If the game is in an online match stop it
				get_tree().network_peer = null
				get_tree().call_group("menu","toggle_disconnect")
			#Now we begin the game with the presets from the campaign map. 
			begin_match()

remote func begin_match():#Starts the match.
	var new_scene = load(match_settings.level)
	get_tree().change_scene_to(new_scene)
	var is_network = get_tree().has_network_peer()#If there is a network game involved
	get_tree().call_group("hud","create_match",match_settings,is_network)

##Inventory
remote func i_set_nickname(playern,text,color):#Sets the nick name of a player
	match_settings.players[playern]["nickname"] = [text,color]

remote func i_set_inven(playern,what,thing,nodereturn,thingnum = 0):#Sets an inventory item of a player
	var invres = load("res://scripts/inventoryres.gd")
	match(what):
		("mecha"):
			match_settings.players[playern]["player_res"] = invres.get_mechas()[thing][0]
		("decoy"):
			match_settings.players[playern]["decoy_res"] = invres.get_decoys()[thing]
		("unit"):
			var uni_set = invres.get_units()[thing]
			uni_set.append(thing)
			match_settings.players[playern]["units_res"][thingnum] = uni_set
		("part"):
			match_settings.players[playern]["parts_res"][thingnum] = invres.get_parts()[thing]
		("weapon"):
			match_settings.players[playern]["weapons_res"][thingnum] = invres.get_weapons()[thing]

	nodereturn.set_text(str(thing))

remote func i_on_confirm(indx,type,playern,nodereturn,thingnum = 0):#Confirms a item has be switch in a player's inventory
	var popup = get_node("../../general_popup")
	var stuff = popup.get_node("stuff")
	var selection
	for s in stuff.get_children():
		selection = s

	var sel = selection.get_item_text(indx)
	i_set_inven(playern,type,sel,nodereturn,thingnum)

	get_tree().call_group("menu","reset_popup")

func i_spawn_inventory(list,type,playern,nodereturn,thingnum = 0):#Creates the item select menu for Inventory 
	var popup = get_node("../../general_popup")
	popup.visible = true

	var inven = ItemList.new()
#	inven.set_anchors_preset(15)
	inven.set_h_size_flags(3)
	inven.set_v_size_flags(3)
	inven.connect("item_selected",self,"i_on_confirm",[type,playern,nodereturn,thingnum])
	popup.get_node("stuff").add_child(inven)
	for li in list:
		inven.add_item(li)

##Online Connections
func welcome_player(id):#set up a online player with a new match_setting
	var factionn#Get the last known faction from match_settings
	if(get_tree().is_network_server()):#Add to the network's settings to the server
		if(match_settings.players[match_settings.players.size()-1]["p_faction"] == 1):#make this player's faction opposing the last faction shown 
			factionn = 2
		else:
			factionn = 1
		add_match_setting("res://scripts/player.gd",factionn,[str(id),"0000ff"],id)
	else:#IF a client update from network.
		send_match_settings()#Tells the server to send the settings over

func _player_connected(id):#When a peer connects
	get_tree().call_group("menu","reprint",str(id)+": has connected")
	welcome_player(id)

func _player_disconnected(id):#When a peer disconnects
	get_tree().call_group("menu","reprint",str(id)+": has disconnected")

	#Determine what is the playern of the ID by looking at the nickname
	var playern = 0
	for nn in match_settings.players:
		if(nn["nickname"][0] == (str(id))):
			print("match lobby, disconnect works")
			remove_match_setting(playern)
		else:
			playern += 1 

func _connected_ok():#When a connection is confirmed
	get_tree().call_group("menu","reprint",str(get_tree().get_network_unique_id())+"(You): has connected")

func _connected_fail():#When a connection does not make it through
	get_tree().call_group("menu","reprint","Failed to connect")
func _server_disconnected():#When the server is disconnect/kick you
	get_tree().call_group("menu","reprint","Server: has died")

##MAIN
func _ready():
	add_to_group("match_lobby")

	L = LEVELRES.new()
	var invres = INVRES.new()
	
	match_settings = MS.new()

#For level select
	form_level_select()
	get_node("selection/sel/levelselect").connect("item_selected",self,"m_on_level_change")
	get_node("selection/sel/modeselect").connect("item_selected",self,"m_on_mode_change")
#For player amount changing
	match(lobby_mode):
		lobbytype.LOCAL, lobbytype.QP:
			get_node("match_players/numofmatch").connect("value_changed",self,"m_on_player_amount_change")
			m_on_player_amount_change(2)
			get_node("beginmatch").connect("pressed",self,"m_on_begin_match")
		lobbytype.STORY:#Diables options, and lets the match settings be determined only by the campaign map
			get_node("match_players/numofmatch").editable = false#The player only needs to see what he is up against
			get_node("selection/sel/levelselect").disconnect("item_selected",self,"m_on_level_change")
			get_node("selection/sel/modeselect").disconnect("item_selected",self,"m_on_mode_change")

			m_on_player_amount_change(match_settings["players"].size())
			get_node("beginmatch").connect("pressed",self,"m_on_begin_match")#The player will begin the match by pressing the button.
		(lobbytype.LAN):
			get_tree().call_group("menu","reprint","Server: has started")
			get_tree().call_group("menu","toggle_disconnect")
			var tre = get_tree()
			tre.connect("network_peer_connected", self, "_player_connected")
			tre.connect("network_peer_disconnected", self, "_player_disconnected")
			tre.connect("connected_to_server", self, "_connected_ok")
			tre.connect("connection_failed", self, "_connected_fail")
			tre.connect("server_disconnected", self, "_server_disconnected")
			if(tre.is_network_server()):
				get_node("beginmatch").connect("pressed",self,"m_on_begin_match")
			else:
				get_node("beginmatch").disabled = unchangable