extends "res://scripts/unit_entity.gd"

###The base of mech command units
#description
var nickname = ["player","ffffff"]
var trackingn = 0 #The tracking number of the player for vcon and hud's victory screen
#monitoring
var lives = 3
var healrate = 1
var money = 1150
var resources = [0,0,0,0,0,0,0]#This is an array as the resource point uses an enum to determine where the value goes
var is_healing = false
#spawning
var spawn_point # For when the mecha respawns.
var is_respawning = false
export(bool) var is_KA = false
#weopons
var parts = ["",""]
#command
var mecha_unit_ready_list = []
var mecha_unitnames_ready_list = []

var unit_list = []#0 = The scene of the unit to load,1 = The Time it takes, 2 = The unit cost in money, 3 = name of the unit
var inventory = []
var units_pickupable = []
var units_commandable = []

##monitor
sync func set_lives(value):
	get_tree().call_group(str(trackingn)+"vcon","set_camsock")
	lives = lives - value
	get_tree().call_group("player_ui"+str(trackingn),"set_counter",lives)
	if(lives > 0):#Respawn if has another life
		if(spawn_point != null):
			if(typeof(weakref(spawn_point).get_ref()) != TYPE_NIL):
				#Get the resource path of the mecha
				var playerdata = {"input_con":input_script,
						"player_res": self.filename,
						"decoy_res":[decoyammo, decoy_timer],
						"units_res":unit_list,
						"parts_res":parts,
						"weapons_res":gun,
						"p_faction":faction,
						"nickname":nickname,
						"id":get_network_master(), #This is only for online play
						"playern":playern, #This is for local play's controller use
				}

				spawn_point.spawn_new(spawn_point,playerdata,trackingn,true,lives)
	else:#When A player has no more lives
		get_tree().call_group("hud","player_died",trackingn)

func set_money(value):
	money = money - value
	get_tree().call_group("player_ui"+str(trackingn),"set_player_wallet",money)

func set_resource(rtype,rvalue):
	resources[rtype] -= rvalue
	get_tree().call_group("player_ui"+str(trackingn),"set_player_resources",resources)

##command
func command_selected(ai_actions):#Commands the units in the command center
	for unt in units_commandable:
		if(unt.has_node("input_con")):
			unt.get_node("input_con").set_ai_behavior(ai_actions)

func buy_a_unit(unitvalue):#Buys a unit
	if(typeof(unitvalue) == TYPE_INT):
		if(money > 0):
			money = money - unit_list[unitvalue][2]
			var tre = get_tree()
			tre.call_group("player_ui"+str(trackingn),"purchase_unit",unit_list[unitvalue],playern,money,unit_list[unitvalue][3])

func add_unit_to_list(unit,pnumcom = playern):#Adds the finished built unit to the ready list, NOT YET PICKED UP!
	if(pnumcom == playern):
		mecha_unit_ready_list.append(unit)

slave func pickup_unit(nunit,nunitname = "?"):#This picks up a unit off the ground
	inventory.append(nunit)

	if(input_script == "res://scripts/player.gd"):#If the mecha is a player then update the player's hud.
		get_tree().call_group("player_ui"+str(trackingn),"add_inv",nunitname)

	if(get_tree().has_network_peer() && (is_network_master())):#If online pickup unit on the other players' screen
		rpc_unreliable("pickup_unit",nunit,nunitname)

slave func pickup_ready_unit():#This removes the unit from the ready list.
	mecha_unit_ready_list.remove(0)
	get_tree().call_group("player_ui"+str(trackingn),"remove_qtag")

	if(get_tree().has_network_peer() && (is_network_master())):#If online pickup unit on the other players' screen
		rpc_unreliable("pickup_ready_unit")

slave func drop_unit(nunit,gsound = "res://assets/audio/sounds/hummingbird.ogg"):#Drops a unit/decoy
	if(get_tree().has_network_peer() && (is_network_master())):#If online deploy unit on the other players' screen, 
	#this must be done first because nunit gets turn into an object later down the code, needs to be a string.
		rpc_unreliable("drop_unit",nunit,gsound)

	var claw = get_node("claw")
	nunit = load(nunit).instance()

	nunit.playern = playern
	nunit.skin = skin
	if(nunit.has_node("input_con")):
		nunit.get_node("input_con").parent_player = self
	nunit.faction = faction
	nunit.set_global_transform(claw.get_global_transform())
	if(has_node("/root/level/units")):
		get_node("/root/level/units").add_child(nunit)

	if(input_script == "res://scripts/player.gd"):#If the mecha is a player then update the player's hud.
		get_tree().call_group("player_ui"+str(trackingn),"remove_inv",nunit)

	play_sound(gsound)


##Set up
func loadinparts():
	if(parts[0] != ""):
		var partable = load(parts[0]).instance()

		partable.set_network_master(get_network_master())#for network play.

		add_child(partable)
	if(parts[1] != ""):
		var partable = load(parts[1]).instance()

		partable.set_network_master(get_network_master())#for network play.

		add_child(partable)

##Colision
func _unit_in_com(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("unit")):
		if(gparea.playern == playern):
			units_commandable.append(gparea)
			if(gparea.get_node("input_con").get_script() != null):
				gparea.get_node("input_con").toggle_com_ind()
	elif(gparea.is_in_group("decoy")):
		if(gparea.faction == faction):
			if(self.is_in_group("player")):
				units_commandable.append(gparea)

func _unit_out_com(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("unit")):
		if(gparea.playern == playern):
			var findu = units_commandable.find(gparea)
			if(findu != -1):
				units_commandable.remove(findu)
				if(gparea.get_node("input_con").get_script() != null):
					gparea.get_node("input_con").toggle_com_ind()
	elif(gparea.is_in_group("decoy")):
		if(gparea.faction == faction):
			if(self.is_in_group("player")):
				var findu = units_commandable.find(gparea)
				if(findu != -1):
					units_commandable.remove(findu)

func _unit_over(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("unit")):
		units_pickupable.append(gparea)

func _unit_away(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("unit")):
		var findu = units_pickupable.find(gparea)
		if(findu != -1):
			units_pickupable.remove(findu)

##Main
func sub_multiplier(multiplier):
	healrate = healrate * multiplier
	speed = flightsp

func _physics_process(delta):
	gun_handler(delta)
	if(is_healing):
		set_health(-healrate)

func _ready():
	add_to_group(gname+" faction"+str(faction))

	connect("_on_die",self,"set_lives",[1])
	connect("deploy_decoy",self,"drop_unit",[decoyammo])

	#Set up stats
	loadinparts()
	speed = flightsp #Make sure the mecha has the proper speed when spawned

	var clarea = get_node("claw/clarea")

	clarea.connect("area_entered",self,"_unit_over")
	clarea.connect("area_exited",self, "_unit_away")

	var commandarea = get_node("comandarea/carea")
	commandarea.connect("area_entered",self,"_unit_in_com")
	commandarea.connect("area_exited",self,"_unit_out_com")

	#Mecha UI
	var inven = load("res://ui/ui_inven.tscn").instance()
	var inven_lb = inven.get_node("view/label")
	inven.translation = Vector3(0,5,0)
	inven.rotation = Vector3(deg2rad(-40),0,0)
	inven.scale = Vector3(4,4,4)
	inven_lb.text = nickname[0]
	inven_lb.self_modulate = nickname[1]
	add_child(inven)

	#HOVER BUFFER
	#remove collision for area node in player
	create_hover()
	toggle_flight()#Should be flying on spawn.

