extends "res://scripts/projectile.gd"

var target = self.global_transform.origin

func _process(delta):
	if(typeof(target) == TYPE_VECTOR3):
		transform.origin = transform.origin + -global_transform.basis.z.normalized()*speed
	else:
		if(is_instance_valid(target)):
			var rot = Transform(Basis(),global_transform.origin)
			rot = rot.looking_at(target.global_transform.origin,Vector3(0,1,0))
			var move  = global_transform.origin + (-rot.basis.z.normalized()*speed)
			global_transform = Transform(rot.basis,move)

func _a_enter(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("player") || (gparea.is_in_group("decoy")) || (gparea.is_in_group("unit"))):
		if(gparea.faction != faction):
			target = gparea

func _a_exit(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if(gparea.is_in_group("player") || (gparea.is_in_group("decoy")) || (gparea.is_in_group("unit"))):
		if(gparea.faction != faction):
			if(gparea == target):
				target = self.global_transform.origin

func _ready():
	var w = get_node("sensor/w")
	w.connect("area_entered",self,"_a_enter")
	w.connect("area_exit",self,"_a_exit")