extends VSplitContainer

func get_connect_info():
	var connect_info = [get_node("ui_input/man_con").text,
						int(get_node("ui_input/port").text),
						get_node("ui_input/number_of_players").value]
	return connect_info

func _on_join():
	var peer = NetworkedMultiplayerENet.new()
	var connect_info = get_connect_info()
	peer.create_client(connect_info[0],connect_info[1])
	get_tree().network_peer = peer

	var match_lobby = load("res://ui/match_lobby.tscn").instance()
	match_lobby.lobby_mode = 2
	match_lobby.m_on_player_amount_change(connect_info[2])
	get_parent().add_child(match_lobby)

	self.queue_free()

func _on_host():
	var peer = NetworkedMultiplayerENet.new()
	var connect_info = get_connect_info()
	peer.create_server(connect_info[1],connect_info[2])
	get_tree().network_peer = peer

	var match_lobby = load("res://ui/match_lobby.tscn").instance()
	match_lobby.lobby_mode = 2
	get_parent().add_child(match_lobby)
	match_lobby.m_on_player_amount_change(connect_info[2])
	match_lobby.add_match_setting("res://scripts/player.gd",1,["(HOST)"+str(get_tree().get_network_unique_id()),"0000ff"])#Ensures the server starts with at least 1 match_setting

	self.queue_free()

func _ready():
	get_node("ui_input/buthost").connect("pressed",self,"_on_host")
	get_node("ui_input/butjoin").connect("pressed",self,"_on_join")