func save_game(path = "/default.sav"):
	var content = {"controls":{}}
	for act in InputMap.get_actions():
		content["controls"][act] = InputMap.get_action_list(act)
	content["multiplier"] = ProjectSettings.get("Game/Fun/multiplier")
	var file = File.new()
	file.open(path, file.WRITE)
	file.store_var(content)
	file.close()

func load_game(path = "/default.sav"):
	var file = File.new()
	var content = null
	if file.file_exists(path):
		file.open(path, file.READ)
		var vartent = file.get_var()

		if vartent != null:
			content = {}
			for act in vartent["controls"]:
				if typeof(vartent["controls"][act][0]) != TYPE_ARRAY:
					if InputMap.has_action(act):
						InputMap.erase_action(act)
						InputMap.add_action(act)
					elif !InputMap.has_action(act):
						InputMap.add_action(act)
					InputMap.action_add_event(act,vartent["controls"][act][0])
			ProjectSettings.set("Game/Fun/multiplier",vartent["multiplier"])
		else:
			print("Loa-URK! File is empty!")
	else:
		print("Loa-ACK! File does not exist!")

	file.close()
	return content