extends KinematicBody
###The base class of every mmoving object
#Description
var gname = "unit"
var playern = 0 #1-28-2019 this was playern
var faction = 0
enum unit_type {NORMAL,CAPTURE,TURRENT,FLY,ANTI_AIR,DECOY,MECHA}
export(unit_type) var unitmode = 0
export(Color) var skin = Color("909090")#WIP this is not suppose to over ride the material textures.
#move
export var flightsp = 25
export var landsp = 7
var speed = landsp
var vel = Vector3()
var gravity = -1
#monitoring
export var health = 120
var maxhealth = health
var is_flying = false
var is_over_land = true #if this is false then the unit can not land.
var is_over_base = false# if this is true then the unit can not land, but can create units, and other things the base provides.
export(String, FILE) var input_script = ""
#weapons
var are_guns_firing = PoolByteArray([0,0,0])
var gun_multiplier = 8
export var gun = PoolStringArray(["res://objects/guns/basic.tscn",""])
var is_decoy_ready = false
var decoyammo = ""
var decoy_timer = 45
var dt_limit = 45

##Sound
func play_sound(value):
	var lval = load(value)
	if(has_node("sound")):
		var sound = get_node("sound")
		if(lval != null):
			if(lval.is_class("AudioStreamOGGVorbis")):
				lval.loop = false
			if(sound.stream != lval):
				sound.stream = lval
				sound.play()
			if(!sound.playing):
				sound.play()
		else:
			sound.playing = false

##Monitoring
slave func net_die():#queue free isn't a network function. This does it's job online.
	queue_free()

func die():#If the mecha's health is below 0 destroy mech
	if(get_tree() != null):#if the scenetree exists (This is to prevent crashing on the victory screen)
		queue_free()
		if(is_in_group("player")):#The unit is actually a mecha.
			emit_signal("_on_die")
			if(1 == get_tree().get_network_unique_id()):#Network play respawn this mecha on all screens
			#It must check to ensure it activates the function only on one computer. Else it double spawns. 1 == host
				rpc("net_die")

#		if(is_in_group("player")):#The unit is actually a mecha.
#			if(get_tree().network_peer == null):#If locally just call it.
#				call("set_lives",1)
#			elif(1 == get_tree().get_network_unique_id()):#Network play respawn this mecha on all screens
#			#It must check to ensure it activates the function only on one computer. Else it double spawns. 1 == host
#				rpc("net_die")
#				rpc("set_lives",1)#Okay this is the problem... Mecha's func fails to work right online. GRAAAAAAAAAAAAHG!

slave func update_health(he):#Update the unit's health.
	health = he

func set_health(value):
	if(health > -1):#Prevents the player from dying/respawning twice
		if((health - value) <= maxhealth):
			health = health - value
			if(is_in_group("player")):
				get_tree().call_group("player_ui"+str(playern),"set_player_health",health)
			if(health < 0):
				die()
	if(get_tree().network_peer != null):#For network play.
		rpc("update_health",health)

##Weapions
func set_ui_timer(whatnum,value,string_bar):
	var gt = whatnum - (value*gun_multiplier)
	if(is_in_group("player")):
		get_tree().call_group("player_ui"+str(playern),"set_player_rate",string_bar,gt)
	return gt

func gun_handler(delta):
	var gunnery = get_node("pin/guns")
	if(are_guns_firing[0] == 1):
		if(gunnery.has_node("primegun")):
			gunnery.get_node("primegun").fire_gun(playern,faction)
	if(are_guns_firing[1] == 1):
		if(gunnery.has_node("secgun")):
			gunnery.get_node("secgun").fire_gun(playern,faction)
	if(is_in_group("player")):
		if((are_guns_firing[2] == 1) && (is_decoy_ready == true)):
			emit_signal("deploy_decoy")
			is_decoy_ready = false
			decoy_timer = dt_limit
		elif(!is_decoy_ready):
			if(decoy_timer < 0):
				is_decoy_ready = true
			else:
				decoy_timer = set_ui_timer(decoy_timer,delta,"ratedecoy")
	if(are_guns_firing[0] == 0) && (are_guns_firing[1] == 0) && (are_guns_firing[2] == 0) && (get_node("sound").playing): 
		play_sound("")

##Animation
func play_anime(animation,override = false):#Plays an animeation from the meshes/ Scene Root/ Model's animation library
	if(has_node("pin/Scene Root")):#NOTE this uses Godot's better collada exporter plugin for Blender  
		var model = get_node("pin/Scene Root")
		var anime = model.get_node("AnimationPlayer")
		if(anime.has_animation(animation)):
			if(override == true):
				anime.play(animation)
			else:
				anime.queue(animation)

##Movement
func toggle_flight():#Enables flights for the player
	if(is_flying):
		if(!is_over_base && is_over_land):#This is on a seprate line to prevent the else on the other if ladder from kicking in again.
			is_flying = false
			speed = landsp
			play_anime("airtomecha")
	else:
		is_flying = true
		vel.y = 0
		speed = flightsp
		play_anime("mechatoair")
	emit_signal("_on_toggled_flight",is_flying)

slave func update_transform(tform,trot):#This is for online play. set_global_transform isn't declared as a online function
	global_transform = tform
	get_node("pin").rotation = trot#Updates the rotation of the pin

func walk(delta):#Moves the object around the world
	if !is_flying:
		vel.y = gravity
	else:
		if(get_node("hoverbuffer/goup").is_colliding()):
			_on_goup()
		elif(!get_node("hoverbuffer/godown").is_colliding()):#This should colid constantly, if it doesn't the ground is lower.
			_on_godown()
	var movement = vel*speed
	move_and_slide(movement)

	if(get_tree().has_network_peer()):#If online, update this to other players.
		rpc_unreliable("update_transform",global_transform,get_node("pin").rotation)

##HOVERING
func _on_goup():
	global_transform.origin.y = global_transform.origin.ceil().y + 1

func _on_godown():
	global_transform.origin.y = global_transform.origin.ceil().y - 1

##Set up
func set_skin(skins,alpha = 0.99):
	if(has_node("pin/Scene Root")):
		var skeleton = get_node("pin/Scene Root").get_child(0).get_child(0) #trying to get the skeleton of the mesh, blender always sets it 0 child. Example: "pin/Scene Root/mimic/Skeleton"
		if(is_instance_valid(skeleton)):#If there is a skeleton
			for mesh in skeleton.get_children():
				if(mesh.is_class("MeshInstance")):
					var modmat = ShaderMaterial.new() #Modulation material
					var shader = Shader.new()
					var rgb = str(skins.r)+","+str(skins.g)+","+str(skins.b)
					shader.code = "shader_type spatial;void fragment() {ALBEDO = vec3("+rgb+");ALPHA = "+str(alpha)+";}"
					modmat.shader = shader
					mesh.set_surface_material(0,modmat)
#					print("unit_entity.gd",mesh.get_surface_material(0).get_shader_param("albedo"),mesh.name)
	else:
		print("unit_entity.gd: skin could not be set, for there is no modal.")

func loadinguns():
	var gunnery = get_node("pin/guns")
	if(gun[0] != ""):
		var gunable = load(gun[0]).instance()
		gunable.name = "primegun"

		gunable.set_network_master(get_network_master())#for network play.

		gunnery.add_child(gunable)
	if(gun[1] != ""):
		var gunable = load(gun[1]).instance()
		gunable.name = "secgun"

		gunable.set_network_master(get_network_master())#for network play.

		gunnery.add_child(gunable)

func create_camsocket():
	var camsocket = Position3D.new()
	camsocket.name = "camsocket"
	camsocket.transform = Transform(Basis(Vector3(1, 0, 0), Vector3(0, 0.422618, 0.906308),Vector3(0, -0.906308, 0.422618)),Vector3(0, 73, 31))
	add_child(camsocket)

func create_hover():
	var hoverbuffer = Spatial.new()
	var gup = RayCast.new()
	var gown = RayCast.new()
	hoverbuffer.name = "hoverbuffer"
	gup.name = "goup"
	gown.name = "godown"
	gup.enabled = true
	gown.enabled = true
	gup.exclude_parent = true
	gown.exclude_parent = true
	gup.cast_to = Vector3(0,-4,0)
	gown.cast_to = Vector3(0,-5,0)
	gup.collision_mask = 1024
	gown.collision_mask = 1024

	gup.set_network_master(get_network_master())#for network play.
	gown.set_network_master(get_network_master())#for network play.

	hoverbuffer.add_child(gup)
	hoverbuffer.add_child(gown)
	add_child(hoverbuffer)

func create_input_con():
	if(!has_node("input_con")):
		var input_con = Node.new()
		input_con.name = "input_con"
		input_con.set_script(load(input_script))
		input_con.set_network_master(get_network_master())#for network play. If this isn't changed the client mechas will not move..
		add_child(input_con)

func multiplier():#Multiplies the variables if the multiplier is active
	var multiplier = ProjectSettings.get("Game/Fun/multiplier")
	
	health = health * multiplier
	maxhealth = health
	flightsp = flightsp * multiplier
	landsp = landsp * multiplier
	speed = landsp
	if(is_in_group("player")):
		call("sub_multiplier",multiplier)

func create_sound():
	var sound = AudioStreamPlayer3D.new()
	sound.name = "sound"
	sound.max_distance = 0
	sound.unit_db = ProjectSettings.get("Game/Options/sound_volume")
	sound.max_db = 6
	sound.unit_size = 16
	sound.attenuation_model = sound.ATTENUATION_INVERSE_SQUARE_DISTANCE
	add_child(sound)

##Colision
func _on_colid(area):
	var parea = area.get_parent()
	if parea.is_in_group("projectile"):
		if(parea.faction != faction):#Make sure this is not one of ours. 
			set_health(parea.damage)
			parea.queue_free()

##Main
func _physics_process(delta):
	walk(delta)

	gun_handler(delta)

	if((global_transform.origin.y > 900) || (global_transform.origin.y < -500)):#the object has gone out of bounds.
		die()

func _ready():
	add_user_signal("_on_die")
	add_user_signal("deploy_decoy")
	add_user_signal("_on_toggled_flight",[TYPE_BOOL])
	add_user_signal("_on_over_base")

	set_skin(skin)
	loadinguns()
	create_camsocket()
	create_input_con()
	create_sound()
	multiplier()

#Prepare colision
	var pin = get_node("pin")
	pin.add_to_group(gname)
	pin.get_node("area").connect("area_entered",self,"_on_colid")

	#Specific parts of the unit
	match(unitmode):
		(unit_type.NORMAL):
			pass
		(unit_type.CAPTURE):
			pass
		(unit_type.TURRENT):
			if(has_node("input_con")):
				var input_con = get_node("input_con")
				input_con.current_state = input_con.AI_State.TURRENT#There should be a check to see if this is AI based. Cause if player gets loaded in it will crash.
		(unit_type.FLY):
			create_hover()
			toggle_flight()
		(unit_type.ANTI_AIR):
			pass
		(unit_type.DECOY):
			gname = "decoy"
		(unit_type.MECHA):
			gname = "player"
		_:
			print("unit_entity.gd","Unit mode undetermined")
	add_to_group(gname)